package Current.basic;
import Current.*;

import java.math.*;

public class BigComplexInterval {
    public BigInterval x,y;

    public BigComplexInterval() {}

    public BigComplexInterval(BigInterval x,BigInterval y) {
	this.x=x;
	this.y=y;
    }


  
    public static BigComplexInterval plus(BigComplexInterval z1,BigComplexInterval z2) {
        return new BigComplexInterval(BigInterval.add(z1.x,z2.x),BigInterval.add(z1.y,z2.y));
    }

    
    public static BigComplexInterval times(BigComplexInterval z1,BigComplexInterval z2) {
	BigInterval X=new BigInterval();
	BigInterval Y=new BigInterval();
	X=BigInterval.subtract(BigInterval.multiply(z1.x,z2.x),BigInterval.multiply(z1.y,z2.y));
	Y=BigInterval.add(BigInterval.multiply(z1.x,z2.y),BigInterval.multiply(z1.y,z2.x));
	return(new BigComplexInterval(X,Y));
    }

    public static BigComplexInterval conjugate(BigComplexInterval z) {
	    return new BigComplexInterval(z.x,z.y.negate());
    }




}