package Current.basic;
import Current.*;
import java.math.*;

public class BigInterval {
   public  BigInteger L,R;


    public BigInterval() {
	this.L=new BigInteger("0");
	this.R=new BigInteger("0");
    }

    public BigInterval(BigInteger l,BigInteger r) {
	this.L=l;
	this.R=r;
    }

    public BigInterval(int n) {
	Integer N=new Integer(n);
	this.L=new BigInteger(N.toString());
	this.R=new BigInteger(N.toString());
    }


    public BigInterval order() {
	if(this.L.compareTo(this.R)==-1) return(this);
	return(new BigInterval(this.R,this.L));
    }

    public static BigInterval add(BigInterval I,BigInterval J) {
	BigInterval K=new BigInterval();
	K.L=I.L.add(J.L);
	K.R=I.R.add(J.R);
	return(K);
    }

    public static BigInterval subtract(BigInterval I,BigInterval J) {
	BigInterval K=new BigInterval();
	K.L=I.L.subtract(J.R);
	K.R=I.R.subtract(J.L);
        return(K);
    }

    public static BigInterval multiply(BigInterval I,BigInterval J) {
        BigInterval K=new BigInterval();
	BigInteger LL=I.L.multiply(J.L);
	BigInteger LR=I.L.multiply(J.R);
	BigInteger RL=I.R.multiply(J.L);
	BigInteger RR=I.R.multiply(J.R);
	K.L=LL;
	if(K.L.compareTo(LR)==1) K.L=LR;
	if(K.L.compareTo(RL)==1) K.L=RL;
	if(K.L.compareTo(RR)==1) K.L=RR;
	K.R=LL;
	if(K.R.compareTo(LR)==-1) K.R=LR;
	if(K.R.compareTo(RL)==-1) K.R=RL;
	if(K.R.compareTo(RR)==-1) K.R=RR;
        return(K);
    }


    public BigInterval negate() {
	return(new BigInterval(this.R.negate(),this.L.negate()));
    }





}