package Current.gui;

import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;


/*This code implements double buffering, which
  make the paint method in a Canvas work more
  smoothly.*/

public class DBCanvas extends Canvas {
    
    public void update(Graphics g) {
        Graphics g2;
        Image offscreen = null;
        offscreen = createImage(getSize().width, getSize().height);
        g2 = offscreen.getGraphics();
        paint(g2);
        g.drawImage(offscreen, 0, 0, this);
	g2.dispose();
	offscreen.flush();
    }
}

