package Current.manage;

/**
 * This class just encapsulates a string which indicates the filename of a 
 * help document. When passed to the manager using a command such as
 * M.mcbSend(new HelpDocument("about.html"));
 * it tells the manager to try to display the help file "Files/Help/about.html"
 */
public class HelpString {    
    public String str;
    
    public HelpString(String str) {
        this.str=str;
    }
    
    /** Creates a pointer to the help file Files/Help/filename */
    public static HelpString fromBody(String body) {
        StringBuffer b=new StringBuffer();
        b.append("<html>");
        b.append("<body bgcolor=\"#1E90FF\">");
        b.append(body);
        b.append("</body>");
        b.append("</html>");
        return new HelpString(b.toString());
    }    
}
