package Current.plot.Dyadic;

import Current.basic.*;

import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;

/*This is a basic class for a rectangular button button*/

public class SmallPolygon {
    int N;
    Complex[] Z=new Complex[600];
    
    
    public SmallPolygon() {
        //for(int i=0;i<200;++i) Z[i]=new Complex();
        this.N=0;
    }
    
    
    public SmallPolygon(Complex[] Z,int n) {
        this.N=n;
        for(int i=0;i<n;++i) this.Z[i]=new Complex(Z[i].x,Z[i].y);
    }
    
    
    public GeneralPath toGeneralPath() {
        GeneralPath gp=new GeneralPath();
        gp.moveTo((float)(this.Z[0].x),(float)(this.Z[0].y));
        for(int i=1;i<N;++i) gp.lineTo((float)(this.Z[i].x),(float)(this.Z[i].y));
        gp.closePath();
        return gp;
    }
    
    
    public Complex getCenter() {
        Complex Z=new Complex();
        for(int i=0;i<this.N;++i) Z=Complex.plus(Z,this.Z[i]);
        Z=new Complex(Z.x/N,Z.y/N);
        return(Z);
    }
    
    public SmallPolygon doubleAboutCenter() {
        SmallPolygon P=new SmallPolygon();
        P.N=this.N;
        Complex Z=this.getCenter();
        for(int i=0;i<N;++i) {
            P.Z[i].x=2*this.Z[i].x-Z.x;
            P.Z[i].y=2*this.Z[i].y-Z.y;
        }
        return(P);
    }
    
    
    
    
}
