package Current.plot.Plotters;

import Current.basic.*;
import Current.manage.*;
import Current.plot.BilliardLike.*;


import java.awt.Color;
import java.io.Serializable;
import java.awt.Component;
import java.awt.Canvas;

/**
 * The billiard-like plot needs very little to do a plot.
 *
 * @author  pat
 */
public class XBilliardLikePlotter implements XPlotter, Serializable {
    /** default constructor */
    public XBilliardLikePlotter(){}
        
    /** Run the algorithm to plot the tile. */
    public Tile plot(String word, Color C, Interrupter I, Manager M) {
        return BLikeTile.plot(word,C, I);
    }
    
    public Component getController(Manager M){
        return new Canvas();
    }
    
    public String getName() {
        return "b-like";
    }
    
    public boolean canRun() {
        return true;
    }
    
//    public HelpDocument document() {
//        return new HelpDocument("PlottingBilliardLike.html");
//    }
    
    public Color getColor() {
        return new Color(250,150,255);
    }
    
}
