package Current.popups.Deg100;

import Current.*;
import Current.gui.*;
import Current.basic.*;
import Current.manage.*;
import Current.plot.Plotters.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.math.*;


public class Deg100Canvas extends DBCanvas implements MouseListener,Runnable  {
    Manager M;
    Deg100Data D;
    Deg100Document DD;
    Deg100Message DM;
    int select;
    int select2;
    public ListenSquare[] S=new ListenSquare[270];
    public ListenSquare[] V=new ListenSquare[10];
    WordIcon WI;
    ListenSquare[] X=new ListenSquare[22];
    public ListenSquare[][] Y=new ListenSquare[11][11];
    int option;
    Interrupter I;
    int message;
    int boxes;
    int depth;
    int time;


    public Deg100Canvas(Manager M) {
	this.M=M;
	M.addListener(this);
	addMouseListener(this);
        setBackground(new Color(100,0,100));
	setSize(325,623);
	this.D=new Deg100Data();
	Color C=new Color(0,100,100);
	Color C2=new Color(100,0,100);
	defineSpecialPolygons(new Color(50,100,255));
	defineSeries0(C);	
        defineSeries1(C2);	
        defineSeries2(C2);
	defineSeries3(C2);
	defineSeries4(C2);
	defineVertexBoxes();
	select=-1; 
	Color CC=new Color(200,0,200);
        WI=new WordIcon(130,361,187,107,"",1);
	X[0]=new ListenSquare(126,343,196,128,CC);
	message=0;
	boxes=0;
	depth=0;
	time=0;

	for(int i=0;i<=2;++i) {
	    for(int j=0;j<=5;++j) {
		Y[j][i]=new ListenSquare(54+27*i,380+15*j,10,10,new Color(50,100,255));
	    }}


	Y[0][0].on=1;
	Color C3=new Color(50,100,255);
	X[1]=new ListenSquare(3,473,51,17,C3); //recognize
	X[18]=new ListenSquare(107,345,12,12,C3); //test cosine
	X[8]=new ListenSquare(7,345,12,12,C3);	//off button
        X[9]=new ListenSquare(56,473,52,17,C3);  //clear button  
        X[11]=new ListenSquare(240,473,53,17,C3); //documentation
	X[19]=new ListenSquare(110,473,53,18,CC); //rigor option	
        X[20]=new ListenSquare(165,473,73,18,CC); //trace verify option	
        X[12]=new ListenSquare(160,346,11,11,CC); 	  
	X[8].on=0;    
	X[11].on=0;  //documentation
	X[10]=new ListenSquare(305,475,12,12,C2); //info button


	X[2]=new ListenSquare(126,5,95,44,CC);	
        X[3]=new ListenSquare(3,5,120,56,CC);   
        X[4]=new ListenSquare(3,66,120,51,CC);  
        X[6]=new ListenSquare(126,52,95,289,CC);
	X[7]=new ListenSquare(223,5,99,336,CC);  

        X[5]=new ListenSquare(3,122,120,51,CC); 
        X[13]=new ListenSquare(3,178,120,51,CC);   
        X[14]=new ListenSquare(3,234,120,51,CC);  
        X[15]=new ListenSquare(3,290,120,51,CC); 
	X[16]=new ListenSquare(3,343,120,128,CC);
	X[17]=new ListenSquare(3,493,318,127,C3);

	option=0;
	X[12].on=2;
	DD=new Deg100Document(M);
	DM=new Deg100Message();
    }


    public void mcbReceive(int[] stats) {
	boxes=stats[0];
	depth=stats[1];
	time=stats[2];
    }




        public void paint(Graphics gfx) {
            Graphics2D g=(Graphics2D) gfx;
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,    
            RenderingHints.VALUE_ANTIALIAS_ON);
            g.setFont(new Font("Helvetica",Font.PLAIN,10)); 
            for(int i=17;i>=0;--i) X[i].render(g,new Color(50,100,255));  
            drawTiles(g);   
            if(select>=0) drawVertices(-68,62,select,g);  

            if(X[12].on==0) WI.wordRender1(g);
	    if(X[12].on==2) WI.pathRender(g);  
            if(X[12].on==1) WI.wordRender2(g);

	    drawWords(g);
            X[10].infoRender(g);
            X[12].render(g,new Color(50,100,255)); 
            X[18].render(g,new Color(50,100,255));  
            X[19].render(g,new Color(50,100,255));               
            X[20].render(g,new Color(50,100,255));   
	    g.setColor(Color.white);
            if(X[19].on==0) g.drawString("rigor N",117,485);   
            if(X[19].on==1) g.drawString("rigor Y",117,485);
	    for(int i=0;i<=5;++i) {
	    for(int j=0;j<=2;++j) {
		Y[i][j].render(g,new Color(50,100,255));
	    }
	    }
	    g.setColor(Color.white);
            g.drawString("trace verify",172,485);
	    DM.drawMessage(g,message);
	    message=0;
	}

	public void drawWords(Graphics g) {
            g.setColor(Color.white);
            g.setFont(new Font("Helvetica",Font.PLAIN,10)); 
            if(X[11].on==0) g.drawString("doc. off",247,485);     
            if(X[11].on==1) g.drawString("doc. on",247,485); 
	   

            g.drawString("off",23,356);  
            g.drawString("clear",62,485); ;  
            g.drawString("recognize",7,485); 
            g.drawString("test cosine",52,356); 


	    g.drawString("single",39,375);
	    g.drawString("group",73,375);
	    g.drawString("all",108,375);
	    g.drawString("plot",8,388);    
            g.drawString("verify",8,403);   
            g.drawString("cover",8,418);    
            g.drawString("sanity1",8,433);   
            g.drawString("sanity2",8,448);             
            g.drawString("sanity3",8,463);  
 

	    g.setColor(new Color(50,100,250));
            if(X[12].on==0) g.drawString("mode 1: word",175,356);
            if(X[12].on==2) g.drawString("mode 3: hexpath",175,356);
            if(X[12].on==1) g.drawString("mode 2: compressed word",175,356);
	    g.setColor(Color.white);
	}

    public Complex[] getPolygon(int choice) {	
            int n=D.P[choice].n;
            Complex[] BOB=new Complex[n];
	    for(int i=0;i<n;++i) {
		BOB[i]=new Complex(D.P[choice].x[i]/512.0,D.P[choice].y[i]/512.0);
	    }
	    return(BOB);
    }


    public void singleCoverFancy(int choice) {
	if((choice>=7)&&(choice<=221)) {
	Deg100CoveringPolygon dummy=new Deg100CoveringPolygon();
	int[][] record=dummy.coveringAlgorithm(D,choice);
	hardClear();
	if(record[0][0]>0) {
	    for(int i=1;i<=D.P[choice].n;++i) {
		M.setColor(Color.red);
		for(int j=1;j<=record[i][0];++j) {
		    S[record[i][j]].on=1;  
                    S[record[i][j]].C=Color.yellow;
		    singlePlot(record[i][j]);
		}
	    }
	    S[choice].on=1;
	    S[choice].C=Color.yellow;
	    M.setColor(Color.yellow);
	    singlePlot(choice);
	}
	}
	if(choice<7)   {message=11;repaint();}
	if(choice>221) {message=12;repaint();}
    }


    public void singleCover(int choice) {
	Deg100CoveringPolygon dummy=new Deg100CoveringPolygon();
	int[][] record=dummy.coveringAlgorithm(D,choice);
	if(record[0][0]>0) {
	    S[choice].on=1;
	    S[choice].C=Color.yellow;
	}
	repaint();
    }


    public void communicate(int choice) {
        Deg100Interface DI=new Deg100Interface();
	DI.POLY=getPolygon(choice);  //the rational polygon
	DI.D100P=D.P[choice];        //the dyadic polygon
	int[] modes=new int[3];
	modes[0]=X[19].on;      //rigor mode
	modes[1]=2*X[20].on;    //local mode
	modes[2]=choice;        //choice of polygon
	DI.modes=modes;
        // send and wait for message to propagate
        M.mcbSend(DI,true);
    }


		
    public void singlePlot(int choice) {
          M.selectTile(new SearchTile(D.P[choice].W));
	  communicate(choice);
	  WI.W=D.P[choice].W;
	  select=choice;
          setCenter();
          XPolyPlotter plotter=new XPolyPlotter();//M,this);
          I=new Interrupter();
          Tile tile=plotter.plot(D.P[choice].W, M.getColor(), I,M);
	  S[choice].on=1; 
	  S[choice].C=M.getColor(); 
          M.plotTile(tile); 
	  repaint();
    }


		
    public int singleSanityCheck1(int choice) {
	Deg100SanityCheck SC=new Deg100SanityCheck(D.P[choice]);
	int test=SC.check1(choice);
	message=9;
	Integer I0=new Integer(choice);
	String II0=I0.toString();
	if(test==0) DM.S[0]=II0.toString()+" sanity check1 fail  ";
	if(test==1) DM.S[0]=II0.toString()+" sanity check1 pass  ";
	if(test==1) S[choice].on=1;
	repaint();
	return(test);
    }


		
    public int singleSanityCheck2(int choice) {
	Deg100SanityCheck SC=new Deg100SanityCheck(D.P[choice]);
	int test=SC.check2(choice);
	message=9;
	Integer I0=new Integer(choice);
	String II0=I0.toString();
	if(test==0) DM.S[0]=II0.toString()+" sanity check2 fail  ";
	if(test==1) DM.S[0]=II0.toString()+" sanity check2 pass  ";
	if(test==1) S[choice].on=1;
	repaint();
	return(test);
    }


		
    public int singleSanityCheck3(int choice) {
	Deg100SanityCheck SC=new Deg100SanityCheck(D.P[choice]);
	int test=SC.check3(choice);
	message=9;
	Integer I0=new Integer(choice);
	String II0=I0.toString();
	if(test==0) DM.S[0]=II0.toString()+" sanity check3 fail  ";
	if(test==1) DM.S[0]=II0.toString()+" sanity check3 pass  ";
	if(test==1) S[choice].on=1;
	repaint();
	return(test);
    }





    public int allowProof(int choice) {
	int go=0;
	if((choice>=7)&&(choice<=221)) go=1;
	if((choice>=222)&&(choice<=228)) go=choice-220;
	return(go);
    }


    public void singleProve(int choice) {
	int go=allowProof(choice);
	if(go>0) {
	  communicate(choice);
	  M.selectTile(new SearchTile(D.P[choice].W));   //tell manager about tle
	  WI.W=D.P[choice].W;  


          XPoly2Plotter plotter=new XPoly2Plotter();//M,this);  
          I=new Interrupter();
          Tile tile=plotter.plot(D.P[choice].W, M.getColor(), I, M);
	  S[choice].on=1; 
	  S[choice].C=M.getColor(); 
          M.plotTile(tile);   
          message=go;
	  DM.depth=depth;
	  DM.boxes=boxes;
	  DM.time=time;
	  DM.exceptions=D.P[choice].exceptions;
	  if(DM.depth>18) {
	      System.out.println("depth exceeds 18");
              System.exit(0);
	  }
	  if((X[20].on==1)&&(DM.boxes==0)) {
	      message=20;
	  repaint();
	  }
	}
    }



	
    public void totalCover() {
	option=6;
	Thread T=new Thread(this);
	T.start();
    }

    public void groupCover() {
	option=9;
	Thread T=new Thread(this);
	T.start();
    }

	
    public void totalSanityCheck1() {
	option=10;
	Thread T=new Thread(this);
	T.start();
    }

    public void groupSanityCheck1() {
	option=11;
	Thread T=new Thread(this);
	T.start();
    }

    public void totalSanityCheck2() {
	option=12;
	Thread T=new Thread(this);
	T.start();
    }

    public void groupSanityCheck2() {
	option=13;
	Thread T=new Thread(this);
	T.start();
    }

    public void totalSanityCheck3() {
	option=14;
	Thread T=new Thread(this);
	T.start();
    }

    public void groupSanityCheck3() {
	option=15;
	Thread T=new Thread(this);
	T.start();
    }




	
    public void provecosApprox() {
	option=8;
	Thread T=new Thread(this);
	T.start();
    }

    public void totalPlot() {
	option=1;
	Thread T=new Thread(this);
	T.start();
    }

    public void neighborPlot() {
	option=5;
	select2=select;
	Thread T=new Thread(this);
	T.start();
    }


    public void totalProve() {
	option=3;
	Thread T=new Thread(this);
	T.start();
    }

    public void groupProve() {
	option=4;
	Thread T=new Thread(this);
	T.start();
    }


    public void groupPlot() {
	option=2;
	Thread T=new Thread(this);
	T.start();
    }


    public void run() {



	//covering modes

	//covering mode, global
	if(option==6) {
	  for(int i=7;i<=221;++i) {
             singleCover(i);
	  }
	}

	//covering mode, group
	if(option==9) {
	    if((select>=7)&&(select<=29)) {
		for(int i=7;i<=29;++i) singleCover(i);
	    }
	    if((select>=30)&&(select<=221)) {
		for(int i=30;i<=221;++i) singleCover(i);
	    }
	}


	//sanity check modes

	//sanity check1 mode, global
	if(option==10) {
	    int test2=1;
	  for(int i=7;i<=221;++i) {
             test2=test2*singleSanityCheck1(i);
	  }

	  if(test2==0) DM.S[0]="sanity check1 global fail";
	  if(test2==1) DM.S[0]="sanity check1 global pass";

	  message=9;
	  repaint();


	}

	//sanity check1 mode, group
	if(option==11) {
	    int test2=1;
	    if((select>=7)&&(select<=29)) {
		for(int i=select;i<=29;++i) test2=test2*singleSanityCheck1(i);
	    }

	    if((select>=30)&&(select<=221)) {
		for(int i=select;i<=221;++i) test2=test2*singleSanityCheck1(i);
	    }


	  if(test2==0) DM.S[0]="sanity check1 group fail";
	  if(test2==1) DM.S[0]="sanity check1 group pass";

	  message=9;
	  repaint();
	}


	//sanity check2 mode, global
	if(option==12) {
	    int test2=1;
	  for(int i=7;i<=221;++i) {
             test2=test2*singleSanityCheck2(i);
	  }

	  if(test2==0) DM.S[0]="sanity check2 global fail";
	  if(test2==1) DM.S[0]="sanity check2 global pass";

	  message=9;
	  repaint();


	}

	//sanity check2 mode, group
	if(option==13) {
	    int test2=1;
	    if((select>=7)&&(select<=29)) {
		for(int i=select;i<=29;++i) test2=test2*singleSanityCheck2(i);
	    }

	    if((select>=30)&&(select<=221)) {
		for(int i=select;i<=221;++i) test2=test2*singleSanityCheck2(i);
	    }


	  if(test2==0) DM.S[0]="sanity check2 group fail";
	  if(test2==1) DM.S[0]="sanity check2 group pass";

	  message=9;
	  repaint();
	}



	//sanity check3 mode, global
	if(option==14) {
	    int test2=1;
	  for(int i=7;i<=221;++i) {
             test2=test2*singleSanityCheck3(i);
	  }

	  if(test2==0) DM.S[0]="sanity check3 global fail";
	  if(test2==1) DM.S[0]="sanity check3 global pass";

	  message=9;
	  repaint();


	}

	//sanity check3 mode, group
	if(option==15) {
	    int test2=1;
	    if((select>=7)&&(select<=29)) {
		for(int i=select;i<=29;++i) test2=test2*singleSanityCheck3(i);
	    }

	    if((select>=30)&&(select<=221)) {
		for(int i=select;i<=221;++i) test2=test2*singleSanityCheck3(i);
	    }


	  if(test2==0) DM.S[0]="sanity check3 group fail";
	  if(test2==1) DM.S[0]="sanity check3 group pass";

	  message=9;
	  repaint();
	}










	//plot modes


	//plot mode, group
	if(option==2) {

	    if(select<7) singlePlot(select);

	if((select>=7)&&(select<=29)) {
	    for(int i=7;i<=29;++i) singlePlot(i);
	}

	if((select>=30)&&(select<=221)) {
	    for(int i=30;i<=221;++i) singlePlot(i);
	}

	if((select>=222)&&(select<=226)) {
	    for(int i=222;i<=226;++i) singlePlot(i);
	}

	if((select>=227)&&(select<=228)) {
	    for(int i=227;i<=228;++i) singlePlot(i);
	}

	if((select>=229)&&(select<=248)) {
	    for(int i=229;i<=248;++i) singlePlot(i);
	}

	if((select>=249)&&(select<=258)) {
	    for(int i=249;i<=258;++i) singlePlot(i);
	}

	if((select>=259)&&(select<=268)) {
	    for(int i=259;i<=268;++i) singlePlot(i);
	}
	}


	//plot mode, global
	if(option==1) {
	  for(int i=1;i<=221;++i) {
             singlePlot(i);
	  }
	}



	//verify modes


	if(option==4) {
	    int depth2=0;
	    int boxes2=0;
	    int time2=0;
	    message=0;


	    //verify mode, group
	  if((select>=7)&&(select<=29)) {
	    for(int i=select;i<=29;++i) {
              singleProve(i);
	      boxes2=boxes2+boxes;
	      time2=time2+time;
	      if(depth2<depth) depth2=depth;
	    }
	    depth=depth2;
	    boxes=boxes2;
	    time=time2;
	    message=12;
	  }

	  if((select>=30)&&(select<=221)) {

	    for(int i=select;i<=221;++i) {
              singleProve(i);
              if(depth2<depth) depth2=depth;
	      boxes2=boxes2+boxes;
	      time2=time2+time;
	    }
	    depth=depth2;
	    boxes=boxes2;
	    time=time2;
	    message=12;
	  }
	}

	//verify mode, global
	if(option==3) {
	    int depth2=0;
	    int boxes2=0;
	    int time2=0;
	  for(int i=7;i<=221;++i) {
             singleProve(i);
	     boxes2=boxes2+boxes;
	     time2=time2+time;
	     if(depth2<depth) depth2=depth;
	  }
	  message=12;
	  boxes=boxes2;
	  depth=depth2;
	  time=time2;
	}

	//cosine tester
	if(option==8) {
	    int test2=1;
	    int fail=0;
	    int N=(int)(Math.pow(2,21));
	    for(int i=0;i<=N;++i) {

	      int test=Deg100Trig.testCosine(i);
	      if(test2!=test) fail=i;
	      test2=test2*test;
	      if(i%128==0) {
                  message=9;
		  Integer I=new Integer(i);
		  DM.S[0]="testing cosine "+I.toString()+" out of 2097152";
		  if(test2==0) DM.S[0]="fail";
		  repaint();
	      }
	    }
	      if(test2==1) message=12;
	      if(test2==0) message=13;
              repaint();
	}
    }
















    public void selectAction(Point xX) {
	int act=0;
	int ii=-1;
	int jj=-1;
	for(int i=0;i<=5;++i) {
	    for(int j=0;j<=2;++j) {
		if(Y[i][j].inside(xX)==1) {
                  Y[i][j].on=1;
		  ii=i;
		  jj=j;
		}
	    }
	}
	if(ii>=0) {
	for(int i=0;i<=5;++i) {
	    for(int j=0;j<=2;++j) {
		Y[i][j].on=0;
	    }
	}
	Y[ii][jj].on=1;
	X[8].on=0;
	X[9].on=0;
	}
    }



    public void nullAction() {
	for(int i=0;i<=5;++i) {
	    for(int j=0;j<=2;++j) {
		Y[i][j].on=0;
	    }
	}
	X[8].on=0;
	X[9].on=0;
    }







        

 public void drawTiles(Graphics g) {
     for(int i=1;i<=6;++i) {if(S[i].on==0) S[i].render(g,new Color(100,0,0),new Color(255,0,0));}
     for(int i=7;i<=221;++i) {if(S[i].on==0) S[i].render(g,new Color(100,0,100),new Color(255,0,255));}
     for(int i=222;i<=268;++i) {if(S[i].on==0) S[i].render(g,new Color(0,100,100),new Color(0,255,255));}
     for(int i=1;i<=6;++i) {if(S[i].on==1) S[i].render(g,new Color(100,0,0),new Color(255,0,0));}
     for(int i=7;i<=221;++i) {if(S[i].on==1) S[i].render(g,new Color(100,0,100),new Color(255,0,255));}
     for(int i=222;i<=268;++i) {if(S[i].on==1) S[i].render(g,new Color(0,100,100),new Color(0,255,255));}


   //labels
   g.setFont(new Font("Helvetica",Font.PLAIN,10)); 
   g.setColor(Color.white);

   Integer II=new Integer(select);
   if((select>0)&&(select<=221)) {
     g.drawString("interior tiles",140,65);
     g.drawString("vertices of P"+II.toString(),230,18);
   }

   if(select>=222) {
     g.drawString("interior tiles",140,65);
     g.drawString("vertices of tile "+II.toString(),230,18);
   }



   g.drawString("...",106,23);
   g.drawString("...",106,38);
   g.drawString("...",106,303);
   g.drawString("...",106,318);
   g.drawString("covers P1",52,57);
   g.drawString("P2",85,113);
   g.drawString("P3",85,169);
   g.drawString("covers P4",52,225);
   g.drawString("covers P5",52,281);
   g.drawString("covers P6",52,337);


 }


    //boundary markings  


      public void defineSpecialPolygons(Color col) {  
        for(int i=1;i<=6;++i) {
	   S[i]=new ListenSquare(105,-10+56*i,12,col);
	}

	//not used
	S[0]=new ListenSquare(-1,-1,0,0,Color.white);

      }


    //generic tiles

    public void defineSeries0(Color col) {  
      int a=0;
      int b=0;
      for(int i=-8;i<=18;++i) {
	  a=(int)(Math.floor(i/8.0));
	  b=i-a*8;
	   S[i+15]=new ListenSquare(129+11*b,21+11*a,11,col);
      }

      for(int i=16;i<=213;++i) {
	  a=(int)(Math.floor(i/8.0));
	  b=i-a*8;
	   S[i+14]=new ListenSquare(129+11*b,50+11*a,11,col);
      }
    }



      //Pi/4 series of tiles
   public void defineSeries1 (Color col) {
      S[222]=new ListenSquare(8,203,22,col);
      for(int i=1;i<=3;++i) {
      S[222+i]=new ListenSquare(-3+11*i,181,11,col);
      }
      for(int i=0;i<=2;++i) {
      S[225+i]=new ListenSquare(8+11*i,192,11,col);
      }
   }



      //Pi/5 series of tiles
   public void defineSeries2(Color col) {
      for(int i=0;i<=1;++i) {
      S[227+i]=new ListenSquare(8,256+12*i,12,col);
      }
   
   }



      //Pi/6 series of tiles
   public void defineSeries3(Color col) {
      for(int i=0;i<=9;++i) {
      S[249+i]=new ListenSquare(8+9*i,297,9,col);
      }

      for(int i=0;i<=9;++i) {
      S[259+i]=new ListenSquare(8+9*i,312,9,col);
      }
   
   }



    //0 series of tiles
    public void defineSeries4(Color col) {
      for(int i=0;i<=9;++i) {
      S[229+i]=new ListenSquare(8+9*i,17,9,col);
      }

      for(int i=0;i<=9;++i) {
      S[239+i]=new ListenSquare(8+9*i,32,9,col);
      }
    }
    
        
        public void mouseEntered(MouseEvent e) {
        }
        
        public void mouseExited(MouseEvent e) {
        }
        
        public void mousePressed(MouseEvent e) {
        }
        
        public void mouseReleased(MouseEvent e) {
        }

        public void mouseClicked(MouseEvent e) {
	    e.consume();
	    Point xX=new Point();
	    xX.x=e.getX();
	    xX.y=e.getY();	
            if(X[18].inside(xX)==1) provecosApprox();
	    if(X[19].inside(xX)==1) X[19].on=1-X[19].on;  //rigor mode
	    selectAction(xX);
	    int test2=whichPolygon(xX);  
	    if(select>=0) {
               int test3=whichVertex(xX);
               if(test3>=0) {
                V[test3].on=1;
                double x=D.P[select].x[test3];
                double y=D.P[select].y[test3];
		Complex Z=new Complex(x/512.0,y/512.0);
		M.setParameter(Z);
	       }
	    }

	    if(X[1].inside(xX)==1) recognize();
	    if(X[8].inside(xX)==1) {nullAction();X[8].on=1;}
	    if(X[9].inside(xX)==1) hardClear();
	    if(X[11].inside(xX)==1) X[11].on=1-X[11].on;  
            if(X[20].inside(xX)==1) X[20].on=1-X[20].on;
	    if(X[12].inside(xX)==1) {
                ++X[12].on;
		if(X[12].on==3) X[12].on=0;
	    }

	    //documentation
	    if(X[10].inside(xX)==1) DD.summary();
	    if(X[11].on*X[4].inside(xX)==1) DD.boundary();
	    if(X[11].on*X[12].inside(xX)==1) DD.wordDisplay();
	    if(X[11].on*X[7].inside(xX)==1) DD.vertexDisplay();
	    if(X[11].on*X[3].inside(xX)==1) DD.P1Explain();
	    if(X[11].on*X[4].inside(xX)==1) DD.P2Explain();
	    if(X[11].on*X[5].inside(xX)==1) DD.P3Explain();
	    if(X[11].on*X[13].inside(xX)==1) DD.P4Explain();
	    if(X[11].on*X[14].inside(xX)==1) DD.P5Explain();
	    if(X[11].on*X[15].inside(xX)==1) DD.P6Explain();
	    if(X[11].on*Y[0][0].inside(xX)==1) DD.Buttons();
	    if(X[11].on*Y[0][1].inside(xX)==1) DD.Buttons();
	    if(X[11].on*Y[0][2].inside(xX)==1) DD.Buttons();
	    if(X[11].on*Y[1][0].inside(xX)==1) DD.Buttons();
	    if(X[11].on*Y[1][1].inside(xX)==1) DD.Buttons();
	    if(X[11].on*Y[1][2].inside(xX)==1) DD.Buttons();
	    if(X[11].on*Y[2][0].inside(xX)==1) DD.Buttons();
	    if(X[11].on*Y[2][1].inside(xX)==1) DD.Buttons();
	    if(X[11].on*Y[2][2].inside(xX)==1) DD.Buttons();
	    if(X[11].on*X[19].inside(xX)==1) DD.Buttons();
	    if(X[11].on*X[1].inside(xX)==1) DD.Buttons();
	    if(X[11].on*X[8].inside(xX)==1) DD.Buttons();
	    if(X[11].on*X[9].inside(xX)==1) DD.Buttons();
	    repaint();
        }


   public int whichVertex(Point XX) {
      int nv=D.P[select].n;
      int test3=-1;
      for(int i=0;i<nv;++i) {
	  V[i].on=0;
	  if(V[i].inside(XX)==1) test3=i;
      }
      return(test3);
   }


    
    public Complex getCenter() {
	int len=D.P[select].n;
	double x=0;
	double y=0;

	for(int i=0;i<len;++i) { 
            x=x+D.P[select].x[i];
	    y=y+D.P[select].y[i];
	}
	x=x/len;
	y=y/len;
	x=x/512.0;
	y=y/512.0;
	Complex Z=new Complex(x,y);
	return(Z);
    }

    public void setCenter() {
	if(X[20].on==0) {
	Complex Z=getCenter();
	M.setParameter(Z);
	}
    }



    public void removeManagement(){
        M.remove(this);
        M.spaceChanged();
    }

    
    public void recognize() {
	String W1=M.getWord();
	int ii=0;
	for(int i=268;i>=7;--i) {
	    String W2=D.P[i].W;
	    if(W1.compareTo(W2)==0) ii=i;
	}
	if(ii>0) {
	    select=ii;
	    for(int i=1;i<=268;++i) S[i].on=0;
	    S[ii].on=1;
	    repaint();
	}
    }





  public int whichPolygon(Point XX) {
      int test2=-1;
      int dummy=0;

      for(int i=0;i<=D.N;++i) {
	  if(S[i].inside(XX)==1) test2=i;
      }  
      if(test2>=0) {
          select=test2;  
          M.selectTile(new SearchTile(D.P[select].W));
	  communicate(select);
	  WI.W=D.P[select].W;
	  setCenter();  

	  if(Y[0][0].on==1) singlePlot(select);
	  if(Y[0][1].on==1) groupPlot();
	  if(Y[0][2].on==1) totalPlot();

	  if(Y[1][0].on==1) singleProve(select);
	  if(Y[1][1].on==1) groupProve();
	  if(Y[1][2].on==1) totalProve();

	  if(Y[2][0].on==1) singleCoverFancy(select);
	  if(Y[2][1].on==1) groupCover();
	  if(Y[2][2].on==1) totalCover();

          if(Y[3][0].on==1) dummy=singleSanityCheck1(select);
          if(Y[3][1].on==1) groupSanityCheck1();
          if(Y[3][2].on==1) totalSanityCheck1();

          if(Y[4][0].on==1) dummy=singleSanityCheck2(select);
          if(Y[4][1].on==1) groupSanityCheck2();
          if(Y[4][2].on==1) totalSanityCheck2();

          if(Y[5][0].on==1) dummy=singleSanityCheck3(select);
          if(Y[5][1].on==1) groupSanityCheck3();
          if(Y[5][2].on==1) totalSanityCheck3();

	  if(X[9].on==1) hardClear();   
          for(int j=0;j<8;++j) V[j].on=0;

	  if(X[11].on==1) {  //document when on
	     if((select>=7)&&(select<=29)) DD.boundaryExplain();
	     if((select>=30)&&(select<=221)) DD.interiorExplain();
	  }
      }

      return(test2);
  }

    public void hardClear() {
	for(int i=1;i<=268;++i) S[i].on=0;
	M.STM.clear();
	M.spaceChanged();
	repaint();
    }


    public void  defineVertexBoxes () {
      for(int i=0;i<=7;++i) 
      V[i]=new ListenSquare(225,303-38*i,94,35,new Color(155,0,155));
    }

   public void drawVertices(int x,int y,int ind, Graphics g) {

    int nn=D.P[ind].n;
    int tt=D.P[ind].type;
    Integer I=new Integer(0);

    for(int i=0;i<nn;++i) V[i].render(g,Color.black);

    g.translate(x,y);
    g.setFont(new Font("Helvetica",Font.PLAIN,10)); 

    for(int i=0;i<nn;++i) {  

	  if(tt==1) {
	    g.setColor(Color.white);
            g.drawString(I.toString(D.P[ind].k1[i]),300,254-38*i);
	    g.drawString(I.toString(D.P[ind].n1[i]),312,267-38*i);
	    g.setColor(new Color(200,0,200));
	    g.drawLine(300,257-38*i,330,257-38*i);
            g.drawString("2",306,273-38*i); 

	    g.translate(52,0);
	    g.setColor(Color.white);
            g.drawString(I.toString(D.P[ind].k2[i]),300,254-38*i);
	    g.drawString(I.toString(D.P[ind].n2[i]),312,267-38*i);
	    g.setColor(new Color(200,0,200));
	    g.drawLine(300,257-38*i,330,257-38*i);
            g.drawString("2",306,273-38*i);
	    g.translate(-52,0);
	  }

	  if(tt==2) {
            g.setColor(Color.white);
            g.drawString(I.toString(D.P[ind].k1[i]),300,254-38*i);
	    g.drawString(I.toString(D.P[ind].n1[i]),300,267-38*i);
	    g.setColor(new Color(200,0,200));
	    g.drawLine(300,257-38*i,330,257-38*i);

	    g.translate(52,0);
            g.setColor(Color.white);
            g.drawString(I.toString(D.P[ind].k2[i]),300,254-38*i);
	    g.drawString(I.toString(D.P[ind].n2[i]),300,267-38*i);
	    g.setColor(new Color(200,0,200));
	    g.drawLine(300,257-38*i,330,257-38*i);
	    g.translate(-52,0);
	  }

	  if(tt==3) {  
            g.setFont(new Font("Helvetica",Font.PLAIN,8)); 
	     g.setColor(Color.white);
	     Double sx=new Double(D.P[ind].x[i]/512.0);
	     Double sy=new Double(D.P[ind].x[i]/512.0);
	     String SX=sx.toString();
	     String SY=sy.toString();
	     SX=SX.substring(0,8);
	     SY=SY.substring(0,8);
	     g.drawString(SX,300,256-38*i);
	     g.drawString(SY,350,256-38*i);
	  }
    }


    g.setFont(new Font("Helvetica",Font.PLAIN,12));

    if(tt==3) {
       g.setColor(new Color(255,0,255));
       g.drawString("Vertices are",300,32); 
       g.drawString("not rational",300,47);  
       g.drawString("multiples",300,62); 
       g.drawString("of Pi/2.",300,77); 
    }

    g.translate(-x,-y);
   }

   






}







