package Current.popups.Help;

import Current.*;

import Current.manage.*;

import java.awt.Window;

/**
 *
 */
public class HelpOnDemand {
    protected Manager M;
    
    /** Creates a new instance of HelpOnDemand */
    public HelpOnDemand(Manager M) {
        this.M=M;
        M.addListener(this);
        M.PopupM.support(HelpContainer.class,"documentation");
    }
    
    public void mcbReceive(HelpString doc) {
        try {
            Object obj=M.PopupM.getFirstObject(HelpContainer.class);
            if (obj==null) {
                HelpContainer h=new HelpContainer(M,doc);
                M.PopupM.createPopupFromObject(h);
            } 
        } catch (Throwable T) {
            T.printStackTrace();
        }
    }
    
    public void mcbReceive(HelpDocument doc) {
        try {
            Object obj=M.PopupM.getFirstObject(HelpContainer.class);
            if (obj==null) {
                HelpContainer h=new HelpContainer(M,doc.file);
                M.PopupM.createPopupFromObject(h);
            } 
        } catch (Throwable T) {
            T.printStackTrace();
        }
    }
    
    public void mcbCleanup() {
        M.remove(this);
    }
    
}
