/*
 * ImageSaver.java
 *
 * Created on March 8, 2006, 1:46 PM
 */

package Current.popups.ImageSave;

import java.awt.*;

/**
 * An interface that contains information needed to convert to .eps 
 * and .svg files.
 *
 *
 * @author  pat
 */
public interface ImageSaver {
    /** render what to draw to the image file */
    public void imageSave(Graphics G);

    /** width of the image in pixels */
    public int getWidth();

    /** height of the image in pixels */
    public int getHeight();    
    
    /** get background color */
    public Color getBackground();
}
