/*
 * WordListPopper.java
 *
 * Created on September 11, 2006, 11:37 AM
 */

package Current.popups.ListPlotter;

import Current.manage.*;
import Current.manage.Popup.*;

/**
 * This class listens for a WordList from the manager. When it hears one, it pops up 
 * a WordListPlotPopup.
 * @author  pat
 */
public class WordListPopper implements HearingPopup {
    Manager M;
    
    /** Creates a new instance of WordListPopper */
    public WordListPopper(Manager M) {
        this.M=M;
        //M.PopupM.support(Current.popups.OldMemory.FileLoaderContainer.class, "word list plotter");
        M.addListener(this);
    }
    
    public void mcbReceive(WordList wl) {
        WordListPlotPopup wlpp=new WordListPlotPopup(M, wl);
        new PopupWindow("List Plotter", wlpp, this);
    }    
    
    public void popupClosed(java.awt.Component C) {
        ((WordListPlotPopup)(C)).mcbCleanup();
    }
    
    public void mcbCleanup() {
        M.remove(this);        
    }
    
}
