package Current.popups.Polynomial;

import Current.*;
import Current.manage.*;
import Current.popups.Unfold.*;

import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.math.*;

import Current.basic.*;

public class PolynomialCanvas extends Canvas implements MouseListener {

    Manager M;
    String word;
    String[] memword=new String[32];
    int count=0;
    int width,height;
    ListenSquare[] MEM=new ListenSquare[32];
    Polynomial[][] P=new Polynomial[15][15];
    BigPolynomial[][] BP=new BigPolynomial[15][15];
    WordIcon[] WI=new WordIcon[32];
    Color[] COL=new Color[15];
    VertexPair[] V=new VertexPair[32];
    ListenSquare[] L=new ListenSquare[40];
    String Message;
    VertexPair CV;
    PolynomialDisplay[][] PD=new PolynomialDisplay[15][15];
    Complex Zgrab;
    int function=2;
    int level=0;
    int choice=1;
    int compute=0;
    int DEPTH=14;
    int P1,P2,Q1,Q2;
    Complex SCALE;
    BigComplex BSCALE;
    ListenSquare[][] DISPLAY=new ListenSquare[20][20];
    IntegerSelector[] I=new IntegerSelector[20];
    int[][][] FunP=new int[16][4][2000];  
    int[][][] FunQ=new int[16][4][2000];
    int[][][] FunF=new int[16][4][2000];
    BigComplex ZGRAB=new BigComplex();
    int picture=0;
    int precise=0;
    
    
    
    public PolynomialCanvas(Manager M) {
        this.M=M;
        word=M.getWord();
        M.addListener(this);
        setSize(650,420);
        addMouseListener(this);
        newWordReceived();
        COL[0]=new Color(0,0,200);
        for(int i=0;i<=30;++i) {
            MEM[i]=new ListenSquare(165+55*i,85,50,50,COL[0]);
            WI[i]=new WordIcon(165+55*i,85,50,50,"",0);
            WI[i].on=0;
            memword[i]="";
        }
        for(int i=0;i<DEPTH;++i) {
            for(int j=0;j<DEPTH;++j) {
		P[i][j]=new Polynomial();
		BP[i][j]=new BigPolynomial();
		P[i][j].D=-1;
		PD[i][j]=new PolynomialDisplay(0,0,10,1);
		PD[i][j].P=P[i][j];
		PD[i][j].BP=BP[i][j];
            }
        }

	for(int i=0;i<DEPTH;++i) {
	    for(int j=0;j<DEPTH;++j) {
		DISPLAY[i][j]=new ListenSquare(3+13*i,150+13*j,13,13,new Color(0,0,100));
		if((i<4)&&(j<4)) {if(i+j<4) DISPLAY[i][j].on=1;}
	    }
	}

        L[0]=new ListenSquare(200,50,25,25,Color.white); //compute
        L[1]=new ListenSquare(5,2,45,15,Color.white);    //grab
	L[4]=new ListenSquare(5,21,45,15,Color.white);   //insert
        L[3]=new ListenSquare(5,40,45,15,Color.white);    //delete
        L[2]=new ListenSquare(5,60,45,15,Color.white);    //send to unfolding
	L[5]=new ListenSquare(55,2,48,27,Color.white);    //grab coords
	I[0]=new IntegerSelector(57,60,30,14,8,3,20,1);    //rationalizer precision

	L[6]=new ListenSquare(235,2,75,16,Color.white);   //compute raw functions
	L[7]=new ListenSquare(235,21,75,16,Color.white);  //compute polyfit
	I[16]=new IntegerSelector(264,41,30,13,0,0,10,1); //difference & differential operator

	L[12]=new ListenSquare(235,60,17,14,Color.white);   //select P function
	L[13]=new ListenSquare(260,60,17,14,Color.white);   //select Q function
	L[14]=new ListenSquare(293,60,17,14,Color.white);   //select F function

	I[1]=new IntegerSelector(88,84,30,13,12,6,99,1);    //decimal truncation
	I[2]=new IntegerSelector(88,100,30,13,16,5,40,1);   //display width
        I[3]=new IntegerSelector(88,116,30,13,3,1,20,1);    //number of terms
	L[21]=new ListenSquare(65,134,12,12,Color.white);   //lo precision
	L[22]=new ListenSquare(85,134,12,12,Color.white);   //hi precision

	L[9]=new ListenSquare(392,2,16,12,Color.white);   //normalize
	I[4]=new IntegerSelector(365,18,30,12,0,0,12,1);  //dx normalize selector
	I[5]=new IntegerSelector(365,34,30,12,0,0,12,1);  //dy normalize selector
	I[6]=new IntegerSelector(365,50,30,12,0,0,12,1);  //term normalize selector
	I[7]=new IntegerSelector(365,66,30,12,1,1,12,1);  //factorial normalize selctor

	L[17]=new ListenSquare(42,330,13,13,Color.white);    //focus toggle
	L[18]=new ListenSquare(42,346,13,13,Color.white);    //fourier picture toggle
	L[19]=new ListenSquare(42,362,13,13,Color.white);    //fourier picture toggle
	I[8]=new IntegerSelector(100,330,30,13,0,0,12,1);    //focus dx selector
	I[9]=new IntegerSelector(100,346,30,13,0,0,12,1);    //focus dy selector
	I[10]=new IntegerSelector(100,362,30,13,0,0,12,1);   //focus item selector
	I[11]=new IntegerSelector(70,310,30,13,20,10,150,5); //focus scale selector

	L[20]=new ListenSquare(522,2,16,12,Color.white);     //modular transform
	I[12]=new IntegerSelector(485,18,30,12,1,1,99,1);   //x coeff
	I[13]=new IntegerSelector(485,34,30,12,1,1,99,1);   //y coeff
	I[14]=new IntegerSelector(485,50,30,12,12,0,99,1);  //modulus
	I[15]=new IntegerSelector(485,64,30,12,0,0,99,1);   //target value
	L[23]=new ListenSquare(542,2,12,12,Color.white);         //symmetrize


	L[30]=new ListenSquare(146,82,12,12,Color.white);
        L[1].on=1;
	L[5].on=1;
	L[6].on=1;
	L[9].on=0;
	L[14].on=1;
	L[21].on=1;
        assignWidth();
	assignTerms();
	Zgrab=M.getZ();	
	getRationalApproximation();

    }
    


    /**these routines control the global height and width of the display*/


    public void assignWidth() {
	int decimal=I[2].val;
         for(int i=0;i<DEPTH;++i) {
            for(int j=0;j<DEPTH;++j) {
		PD[i][j].x=165+(6*decimal+32)*i;
		PD[i][j].WIDTH=decimal;
	    }
	 }
    }

    public void assignTerms() {
	int terms=I[3].val;
         for(int i=0;i<DEPTH;++i) {
            for(int j=0;j<DEPTH;++j) {
		PD[i][j].y=160+(25*terms+10)*j;
		PD[i][j].TERMS=terms;
	    }
	 }
    }

    public void setBigComplex() {
	BigDecimal XP1=new BigDecimal(P1);
	BigDecimal XQ1=new BigDecimal(Q1);
	BigDecimal XP2=new BigDecimal(P2);
	BigDecimal XQ2=new BigDecimal(Q2);
	BigDecimal X1=XP1.divide(XQ1,100,BigDecimal.ROUND_FLOOR);
	BigDecimal X2=XP2.divide(XQ2,100,BigDecimal.ROUND_FLOOR);
	ZGRAB=new BigComplex(X1,X2);
    }






    private void newWordReceived() {}


    
    
    public void paint(Graphics gfx) {

        Graphics2D g=(Graphics2D) gfx;
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);
        width=getWidth();
        height=getHeight();
	renderFrame(g);
	renderWords(g);
	if(picture==0) renderPolynomials(g);
	if(picture==1) renderFourier(g);
	if((picture==2)&&(L[20].on==0)) renderFocusPolynomials(g);
	if((picture==2)&&(L[20].on==1)) renderModular(g);
	renderCoords(g);
        makeControls(g);
	renderDisplay(g);
    }







    //basic render of polynomials
    public void renderPolynomials(Graphics2D g) {
        for(int i=0;i<DEPTH;++i) {
            for(int j=0;j<DEPTH;++j) {
		if(DISPLAY[i][j].on>0) PD[i][j].render(g);
	    }
        }
    }



    //focus render of polynomial
    public void renderFocusPolynomials(Graphics2D g) {
	int i=I[8].val;
	int j=I[9].val;
	if(precise==0) PD[i][j].TERMS=1+PD[i][j].P.D;
	if(precise==1) PD[i][j].TERMS=1+PD[i][j].BP.D;
	PD[i][j].x=168;
	PD[i][j].y=163;
	PD[i][j].WIDTH=50;
	if(DISPLAY[i][j].on!=0) PD[i][j].render(g);
    }


    //rendering the fourier picture
    public void renderFourier(Graphics2D g) {
	int[] ch=new int[10];
	ch[0]=function;
	ch[1]=I[8].val;  //dx
	ch[2]=I[9].val;  //dy
	ch[3]=I[12].val; //x coeff
	ch[4]=I[13].val; //y coeff
	ch[5]=I[14].val; //modulus
	ch[6]=I[15].val; //target val
	ch[7]=L[23].on;  //symmetrize
	ch[8]=getWidth();
	ch[9]=getHeight();


	int ii=I[10].val;

	if(ch[0]==0) {
    	  FunctionAnalysis FA=new FunctionAnalysis(FunP[ii],ch);
	  FA.render(L[20].on,168,163,g);
	}

	if(ch[0]==1) {
    	  FunctionAnalysis FA=new FunctionAnalysis(FunQ[ii],ch);
	  FA.render(L[20].on,168,163,g);
	}

	if(ch[0]==2) {
    	  FunctionAnalysis FA=new FunctionAnalysis(FunF[ii],ch);
	  FA.render(L[20].on,168,163,g);
	}
    }

    public void renderModular(Graphics2D g) {
      BigDecimal[] K=new BigDecimal[0];
      for(int q=0;q<=I[10].val;++q) {
        K=modularTransformFit(q); 
        g.setFont(new Font("Helvetica",Font.PLAIN,10));
	for(int i=0;i<K.length;++i) {
	    Integer ii=new Integer(i);
	    g.setColor(new Color(50,100,255));
	    g.drawString(ii.toString(),170,180+13*i);
	    g.setColor(Color.white);
	    if(K[i]!=null) {
		if(K[i].compareTo(new BigDecimal(0))==0) g.setColor(new Color(0,150,150));
	    }
	    String S=packageBigDecimal(K[i]);
            g.drawString(S,200+100*q,180+13*i);
	}
      }
    }


      public String packageBigDecimal(BigDecimal X) {
	  if(X==null) return("");
	  String S=new String();
   	  BigDecimal Y=X.divide(new BigDecimal(1),0,BigDecimal.ROUND_FLOOR);
	  S=X.toString();
	  if(X.compareTo(Y)==0) S=Y.toString();
	  if(S.length()>15) S=S.substring(0,14);
	  return(S);
      }




    
    //draw the word icons
    public void renderWords(Graphics2D g) {
        for(int i=0;i<=30;++i) {
            if(memword[i].length()>3) {
                WI[i].pathRender2(g,V[i]);
            }
            if(memword[i].length()<=3) {
                MEM[i].render(g,COL[0]);
            }
        }
    }


    //the frame
     public void renderFrame(Graphics g) {
        g.setColor(Color.black);
        g.fillRect(0,0,width,height);

	g.setColor(new Color(0,90,0));
	g.fillRect(0,0,width,80);
	g.setColor(Color.white);
        g.drawRect(0,0,width,80);

	g.setColor(new Color(100,0,100));
	g.fillRect(0,80,160,height);
	g.setColor(Color.white);
	g.drawRect(0,80,160,height);

	g.setColor(new Color(0,50,255));
	g.fillRect(160,80,width,75);
	g.setColor(Color.white);
	g.drawRect(160,80,width,75);
     }

    //draws strings vertically
    public void verticalDraw(Graphics g,int x,int y,int k,String S) {
	int xx=x;
	int yy=y;
	for(int i=0;i<S.length();++i) {
	    String SS=S.substring(i,i+1);
	    g.drawString(SS,xx,yy);
	    yy=yy+k;
	}
    }


    public void renderDisplay(Graphics g) {
	for(int i=0;i<12;++i) {
	    for(int j=0;j<12;++j) {
		Color Col2=new Color(50,0,50);
		Color Col=new Color(255,0,0);
		DISPLAY[i][j].render(g,Col2,Col,new Color(200,0,200));
	    }
	}

	if(L[17].on+L[18].on>0) {
	  int ii=I[8].val;
	  int jj=I[9].val;
	  Color Col=Color.black;
	  Color Col2=Color.black;
          Col=new Color(255,0,0);
	  DISPLAY[ii][jj].render(g,Col2,Col,new Color(255,255,0));
	}
    }


    public void processDisplay(Point X,int mode) {
	  for(int i=0;i<12;++i) {
	    for(int j=0;j<12;++j) {
		if(DISPLAY[i][j].inside(X)==1) {
		    int temp=DISPLAY[i][j].on;
		    if(temp==0) DISPLAY[i][j].on=1;
		    if(temp!=0) DISPLAY[i][j].on=0;
		}
	    }
	  }
    }

  public void getRationalApproximation() {
        FareyRational X=new FareyRational(0,1);
        FareyRational Y=new FareyRational(0,1);
        X=FareyRational.approximate(Zgrab.x,Math.pow(0.1,I[0].val));
        Y=FareyRational.approximate(Zgrab.y,Math.pow(0.1,I[0].val));
        P1=X.p;
        Q1=X.q;
        P2=Y.p;
        Q2=Y.q;
	int D=BasicMath.gcd(4*Q1,4*Q2);
	int mod=16*Q1*Q2/D;
	if(mod<100) {
	    I[14].val=mod;
	    I[15].val=0;
	    I[15].min=0;
	    I[15].max=mod-1;
	    I[12].val=4*P1*Q2/D;
	    I[13].val=4*P2*Q1/D;
	}
	setBigComplex();
    }

    public void renderCoords(Graphics g) {
	Double X=new Double(Zgrab.x);
	Double Y=new Double(Zgrab.y);
        g.setFont(new Font("Helvetica",Font.PLAIN,10));
        g.setColor(Color.white);  
	g.drawString(X.toString(),112,12);
	g.drawString(Y.toString(),112,25);

        g.setColor(new Color(100,255,100));
	Integer PP1=new Integer(P1);
	g.drawString(PP1.toString(),112,37);
	Integer QQ1=new Integer(Q1);
	g.drawString(QQ1.toString(),112,50);
	int len1=Math.max(PP1.toString().length(),QQ1.toString().length());
	g.drawLine(112,39,112+6*len1,39);

	Integer PP2=new Integer(P2);
	g.drawString(PP2.toString(),112,64);
	Integer QQ2=new Integer(Q2);
	g.drawString(QQ2.toString(),112,77);
	int len2=Math.max(PP2.toString().length(),QQ2.toString().length());
	g.drawLine(112,67,112+6*len2,66);
    }
    
    
    public void makeControls(Graphics g) {


	L[0].render(g,new Color(255,100,0));
        for(int i=1;i<=4;++i) L[i].render(g,new Color(0,150,0));
        L[5].render(g,new Color(0,60,0)); 
	for(int i=6;i<=7;++i) L[i].render(g,new Color(0,160,0));
	L[9].render(g,new Color(0,200,0));
	for(int i=1;i<=3;++i) I[i].render(g,new Color(200,0,200),Color.white,Color.white);

	if(L[9].on==0)
	for(int i=4;i<=7;++i) I[i].render(g,new Color(0,0,0),Color.white,Color.white);
	if(L[9].on==1)
	for(int i=4;i<=7;++i) I[i].render(g,new Color(0,200,0),Color.white,Color.white);
	for(int i=8;i<=11;++i) I[i].render(g,new Color(200,0,200),Color.white,Color.white);

	L[20].render(g,new Color(0,200,0));
	if(L[20].on==0) L[23].render(g,Color.black);
	if(L[20].on==1) L[23].render(g,new Color(0,200,0));
	if(L[20].on==0)
	for(int i=12;i<=15;++i) I[i].render(g,new Color(0,0,0),Color.white,Color.white);
	if(L[20].on==1)
	for(int i=12;i<=15;++i) I[i].render(g,new Color(0,200,0),Color.white,Color.white);
        if(I[16].val==0) I[16].render(g,new Color(0,0,0),Color.white,Color.white);
        if(I[16].val>0)  I[16].render(g,new Color(0,200,0),Color.white,Color.white);

	for(int i=0;i<=0;++i) I[i].render(g,new Color(0,100,0),Color.white,Color.white);
	for(int i=12;i<=14;++i) L[i].render(g,new Color(0,160,0));
	for(int i=17;i<=19;++i) L[i].render(g,new Color(200,0,200));
	for(int i=21;i<=22;++i) L[i].render(g,new Color(200,0,200));

        g.setFont(new Font("Helvetica",Font.PLAIN,10));
	L[30].infoRender(g);
        g.setColor(Color.white);

        g.drawString("grab",8,13);
        g.drawString("insert",8,32);
        g.drawString("delete",8,51);
        g.drawString("send",8,70);

	g.drawString("grab",58,13);
	g.drawString("coords",58,26);
	g.drawString("rational",58,41);
	g.drawString("precision",58,54);

        g.drawString("GO",205,67);
	g.drawString("raw values",240,13);
	g.drawString("polynomial fit",240,33);
	g.drawString("diff",240,53);

	g.drawString("normalize",333,13);
	g.drawString("dx",333,28);
	g.drawString("dy",333,44);
	g.drawString("term",333,60);
	g.drawString("!value",333,74);

	g.drawString("modular transform",433,13);
	g.drawString("coeff x",433,28);
	g.drawString("coeff y",433,44);
	g.drawString("modulus",433,60);
	g.drawString("target",433,76);
	g.drawString("sym",561,13);

        g.drawString("P",240,71);
	g.drawString("Q",265,71);
	g.drawString("F",298,71);
	g.drawString("decimal truncate",5,94);
        g.drawString("display width",5,110);	
        g.drawString("# of terms",5,127);	
        g.drawString("precision: lo",5,145);
        g.drawString("hi",102,145);

	g.drawString("focus ",10,340);	
        g.drawString("pix",10,356);	
        g.drawString("array",10,372);
	g.drawString("dx",72,340);
	g.drawString("dy",72,356);	
        g.drawString("term",72,372);	
        g.drawString("scale",32,322);
	
    }
    

    public void fit(int a1,int a2) {
        int stc=suitableToCompute(a1,a2); 

	if(stc==0) {
             P[a1][a2].D=-1;	
             BP[a1][a2].D=-1;
	}

	if(stc!=0) {
             P[a1][a2].D=count-1;	
             BP[a1][a2].D=count-1;
	}

	if((stc==1)&&(precise==0)) {

	    if(compute==0)  {
	       for(int i=0;i<I[16].val;++i) P[a1][a2]=P[a1][a2].difference();
	    }

	    if(compute==1)  {
               P[a1][a2]=P[a1][a2].fitPolynomial();
	       for(int i=0;i<I[16].val;++i) P[a1][a2]=P[a1][a2].derivative();
	    }
	}

	if((stc==1)&&(precise==1)) {  


	    if(compute==0)  {
	       for(int i=0;i<I[16].val;++i) BP[a1][a2]=BP[a1][a2].difference();
	    }

	    if(compute==1)  {
               BP[a1][a2]=BP[a1][a2].fitPolynomial();
	       for(int i=0;i<I[16].val;++i) BP[a1][a2]=BP[a1][a2].derivative();
	    }
	}
    }






    public void finalize(int a1,int a2,Complex SC) {   
       int stc=suitableToCompute(a1,a2); 
       if(stc==1) {
           P[a1][a2]=P[a1][a2].scale(SC); 
           P[a1][a2]=P[a1][a2].recognizeInteger(I[1].val);
       }

       PD[a1][a2].P=P[a1][a2];
       PD[a1][a2].mode=0;
    }



    public void bigFinalize(int a1,int a2,BigComplex SC) {   
       int stc=suitableToCompute(a1,a2); 
       if(stc==1) {
	   BP[a1][a2]=BP[a1][a2].scale(SC); 
           BP[a1][a2]=BP[a1][a2].recognizeInteger(I[1].val);
       }
       PD[a1][a2].BP=BP[a1][a2];
       PD[a1][a2].mode=1;
    }



    public void setCount() {
        count=0;
        while(V[count]!=null) ++count;
    }

    public void getFunctions() {
	setCount();

	       PrecisionTrigData DATA=new PrecisionTrigData();
	       if((L[20].on==0)&&(precise==1)) { 
                   double time1=System.currentTimeMillis();
		   if(function==0) DATA=new PrecisionTrigData(FunP,count,0,ZGRAB);
		   if(function==1) DATA=new PrecisionTrigData(FunQ,count,0,ZGRAB);
		   if(function==2) DATA=new PrecisionTrigData(FunF,count,1,ZGRAB);
	           double time2=System.currentTimeMillis();
	           double time=time2-time1;
	           System.out.println("precision compute time " +time);
	       } 

	       for(int i=0;i<count;++i) setPolynomial(i,DATA);

	for(int a1=0;a1<DEPTH;++a1) {
	    for(int a2=0;a2<DEPTH;++a2) {
		fit(a1,a2);
	    }
	}

	setNormalize();
	for(int a1=0;a1<DEPTH;++a1) {
	    for(int a2=0;a2<DEPTH;++a2) {
		if(precise==0) finalize(a1,a2,SCALE);
		if(precise==1) bigFinalize(a1,a2,BSCALE);

	    }
	}
    }


    public int suitableToCompute(int a1,int a2) {
	if(compute==0) return(1);
	if(count>a1+a2+2) return(1);
	return(0);
    }





     public void setNormalize() {
	SCALE=new Complex(1,0);	
        BigComplex ONE=new BigComplex(new BigDecimal(1),new BigDecimal(0));
        BSCALE=new BigComplex(new BigDecimal(1),new BigDecimal(0));

	int dx=I[4].val;
	int dy=I[5].val;
	int term=I[6].val;
	int fac=1;	
        for(int i=1;i<=I[7].val;++i) fac=fac*i;

	if((precise==0)&&(L[9].on==1)) {
		try{
		    SCALE=new Complex(P[dx][dy].z[term]);
                    if(SCALE.norm()<.000001) SCALE=new Complex(1,0);
		    SCALE=SCALE.inverse();
		    SCALE=new Complex(fac*SCALE.x,fac*SCALE.y);
		}
		catch(Exception e){}
	}

	if((precise==1)&&(L[9].on==1)) {
		try{
		    BSCALE=new BigComplex(BP[dx][dy].z[term]);  
                    Complex temp=BSCALE.toComplex();
                    if(temp.norm()<.000001) BSCALE=ONE;
		    BSCALE=BigComplex.divide(ONE,BSCALE);
		    BSCALE.x=BSCALE.x.multiply(new BigDecimal(fac));
		    BSCALE.y=BSCALE.y.multiply(new BigDecimal(fac));
		}
		catch(Exception e){}
	}
     }



    public void setPolynomial(int i,PrecisionTrigData DATA) {

	for(int a1=0;a1<DEPTH;++a1) {
	   for(int a2=0;a2<DEPTH;++a2) {

	     if((L[20].on==0)&&(DISPLAY[a1][a2].on!=0)&&(precise==0)) {
	        if(function==0) P[a1][a2].z[i]=Function.derivative(FunP[i],a1,a2,Zgrab);
		if(function==1) P[a1][a2].z[i]=Function.derivative(FunQ[i],a1,a2,Zgrab);
		if(function==2) {
		    double x1=Function.foilDerivative(FunF[i],a1,a2,Zgrab);
		    P[a1][a2].z[i]=new Complex(x1,0);
		}
	     }


             if((L[20].on==0)&&(DISPLAY[a1][a2].on!=0)&&(precise==1)) {
		   if(function==0) BP[a1][a2].z[i]=PrecisionFunction.derivative(DATA,FunP[i],a1,a2,ZGRAB);
		   if(function==1) BP[a1][a2].z[i]=PrecisionFunction.derivative(DATA,FunQ[i],a1,a2,ZGRAB);
		if(function==2) {
		    BigDecimal x1=PrecisionFunction.foilDerivative(DATA,FunF[i],a1,a2,ZGRAB);
		    BP[a1][a2].z[i]=new BigComplex(x1,new BigDecimal(0));
		}
	     }

               if((L[20].on==1)&&(DISPLAY[a1][a2].on!=0)) {
		   BP[a1][a2].z[i]=modularTransform(a1,a2,i,I[15].val);
		   DISPLAY[a1][a2].on=2;
	       }
	   }
	}

    }


    public BigDecimal[] modularTransformFit(int j) {
        BigDecimal[] K=new BigDecimal[I[14].val];
	for(int target=0;target<I[14].val;++target) {
	    K[target]=modularTransformFitTarget(target,j);
	}
	return(K);
    }



    public BigDecimal modularTransformFitTarget(int target,int j) {
	setCount();
	BigPolynomial X=new BigPolynomial();
	X.D=count-1;
	for(int i=0;i<count;++i) {
	    X.z[i]=modularTransform(I[8].val,I[9].val,i,target);
	}
	X=X.fitPolynomial();
	if(X.D==-1) return(null);
	if(j<=X.D) return(X.z[j].x);
	return(new BigDecimal(0));
    }



    //evaluating the modular transform
    public  BigComplex modularTransform(int a1,int a2,int i,int target) {
	int[] ch=new int[11];
	ch[0]=function;
	ch[1]=a1;  //dx
	ch[2]=a2;  //dy
	ch[3]=I[12].val; //x coeff
	ch[4]=I[13].val; //y coeff
	ch[5]=I[14].val; //modulus
	ch[6]=target;
	ch[7]=L[23].on;  //symmetrize
	ch[8]=getWidth();
	ch[9]=getHeight();

	if(ch[0]==0) {
    	  FunctionAnalysis FA=new FunctionAnalysis(FunP[i],ch);
	  return(FA.evaluate());
	}

	if(ch[0]==1) {
    	  FunctionAnalysis FA=new FunctionAnalysis(FunQ[i],ch); 
          return(FA.evaluate());
	}

	if(ch[0]==2) {
    	  FunctionAnalysis FA=new FunctionAnalysis(FunF[i],ch); 
          return(FA.evaluate());
	}
	return(new BigComplex());
    }


    public void grabCoordinates() {
	Zgrab=M.getZ();
	getRationalApproximation();
    }



    public void grab(int test) {
            memword[test]=word;
            WI[test].W=word;
            V[test]=CV;
	    if(word.length()>3) {
	     try {
	         CombinatorialTriangle[] CT=new CombinatorialTriangle[word.length()+3]; 
                 CT=CombinatorialTriangle.unfold(word);
                 CT=CombinatorialTriangle.assignTails(CT);
                 FunQ[test]=Function.computeDenominator(CV,CT);
	         FunP[test]=Function.getSignedNumerator(FunQ[test],CV,CT);
	         FunF[test]=Function.foil(FunP[test],FunQ[test]);
	     }
	     catch(Exception e){}
	    }
	    noSpace();
    }



    public void insert(int test) {

	    setCount();
	    for(int j=count;j>test;--j) {
		memword[j]=new String(memword[j-1]);
		WI[j].W=new String(WI[j-1].W);
		V[j]=new VertexPair(V[j-1].o1,V[j-1].e1,V[j-1].o2,V[j-1].e2);
		FunP[j]=FunP[j-1];
		FunQ[j]=FunQ[j-1];
		FunF[j]=FunF[j-1];
	    }


            memword[test]=word;
            WI[test].W=word;
            V[test]=CV;
	    if(word.length()>3) {
	     try {
	         CombinatorialTriangle[] CT=new CombinatorialTriangle[word.length()+3]; 
                 CT=CombinatorialTriangle.unfold(word);
                 CT=CombinatorialTriangle.assignTails(CT);
                 FunQ[test]=Function.computeDenominator(CV,CT);
	         FunP[test]=Function.getSignedNumerator(FunQ[test],CV,CT);
	         FunF[test]=Function.foil(FunP[test],FunQ[test]);
	     }
	     catch(Exception e){}
	    }
	    noSpace();
    }


        
    public void send(int test) {
            if((V[test]!=null)&&(memword[test].length()>3))	{
                for(int i=0;i<=9;++i)  WI[i].on=0;
                M.selectTile(new SearchTile(memword[test]));
                try{M.mcbSend(V[test]);}
                catch(Exception ee){}
                WI[test].on=1;
            }
        }
        

    public void omit(int test) {
	memword[test]="";
	V[test]=null;
	WI[test].W="";
	noSpace();
    }





    public void noSpace() {
	count=0;
	for(int i=0;i<24;++i) {
	    if((V[i]!=null)&&(memword[i].length()>3)) {
		memword[count]=new String(memword[i]);
		WI[count].W=new String(memword[i]);
		V[count]=new VertexPair(V[i].o1,V[i].e1,V[i].o2,V[i].e2);
		FunP[count]=FunP[i];
		FunQ[count]=FunQ[i];
		FunF[count]=FunF[i];
		++count;
	    }
	}
	for(int i=count;i<24;++i) {
	    V[i]=null;
	    memword[i]="";
	    WI[i].W="";
	}
    }


    
    public void mousePressed(MouseEvent e) {
        MouseData MD=MouseData.process(M,e);
	Point X=MD.X;
	int mode=MD.mode;
	if(L[0].inside(X)==1) L[0].on=1;
	repaint();
    }




    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    
    public void mouseClicked(MouseEvent e) {
        MouseData MD=MouseData.process(M,e);
	Point X=MD.X;
	int mode=MD.mode;
        L[0].on=0;
        int test=-1;
        for(int i=0;i<=12;++i) {
            if(MEM[i].inside(X)==1) test=i;
        }
        
	//memory functions
        if((choice==1)&&(test!=-1)) grab(test);
        if((choice==2)&&(test!=-1)) send(test);
	if((choice==3)&&(test!=-1)) omit(test);	
	if((choice==4)&&(test!=-1)) insert(test);	
        if(L[5].inside(X)==1) grabCoordinates();
        
	toggleOptions(X);
	processDisplay(X,mode);
	modifyDisplay(X,mode);

	if(L[0].inside(X)==1) getFunctions();
	if(L[20].on==1) getFunctions();
	if(L[30].inside(X)==1) document();

        repaint();
    }


    public void modifyDisplay(Point X,int mode) {
	if(L[9].inside(X)==1) L[9].on=1-L[9].on;	
        if(L[20].inside(X)==1) L[20].on=1-L[20].on;
	if(L[20].on==1) {
	    precise=1;
	    L[21].on=0;
	    L[22].on=1;
	}
	if(L[23].inside(X)==1) L[23].on=1-L[23].on;
	for(int i=0;i<=16;++i) I[i].modify(X);
	if(I[0].isModified(X)==1) getRationalApproximation();
	assignWidth();
	assignTerms();
	if(level<0) level=0;
    }

    public void toggleOptions(Point X) {

	int test2=-1;
	for(int i=1;i<=4;++i) if(L[i].inside(X)==1) test2=i;
	if(test2!=-1) {
	    for(int i=1;i<=4;++i) L[i].on=0;
	    choice=test2;
	    L[test2].on=1;
	}

	test2=-1;
	for(int i=6;i<=7;++i) if(L[i].inside(X)==1) test2=i;
	if(test2!=-1) {
	    for(int i=6;i<=7;++i) L[i].on=0;
	    compute=test2-6;
	    L[test2].on=1;
	}

	test2=-1;
	for(int i=12;i<=14;++i) if(L[i].inside(X)==1) test2=i;
	if(test2!=-1) {
	    for(int i=12;i<=14;++i) L[i].on=0;
	    function=test2-12;
	    L[test2].on=1;
	}

	test2=-1;
	for(int i=17;i<=19;++i) if(L[i].inside(X)==1) test2=i;
	if(test2!=-1) {
	    for(int i=17;i<=19;++i) L[i].on=0;
	    picture=19-test2;
	    L[test2].on=1;
	}


	test2=-1;
	for(int i=21;i<=22;++i) if(L[i].inside(X)==1) test2=i;
	if(test2!=-1) {
	    for(int i=21;i<=22;++i) L[i].on=0;
	    precise=test2-21;
	    L[test2].on=1;
	}





    }



    public void document() {
        M.mcbSend(new HelpDocument("PolynomialCanvas.html"));
    }    
    
    
    /** This is called when the popup is closed */
    public void mcbCleanup() {
        M.remove(this);
    }
    
    /** This will be called when a new tile is selected or a new word is selected */
    public void mcbReceive(Tile t) {
        word=t.getStringWord();
        newWordReceived();
    }
    
    public void mcbReceive(VertexPairDummy v) {
        CV=new VertexPair(v.o1,v.e1,v.o2,v.e2);
    }
    
}



