/*
 * StringSelector.java
 *
 * Created on August 27, 2006, 9:27 PM
 */

package Current.popups.Settings.Items;

import java.io.Serializable;

/**
 *
 * @author  pat
 */
public class StringSelector implements Serializable {
    private int i;
    private String array[];
    private String help=null;
    
    /** Creates a new instance of StringSelector */
    public StringSelector(String array[]) {
        this.i=0;
        this.array=array;        
    }
    
    public String[] getArray() {
        return array;
    }
        
    /** return the index of the currently selected string */
    public int getI() {
        return i;        
    }
    
    /** return the currently selected string */
    public String get() {
        return array[i];
    }
    
    /** toggle the selected string */
    public void toggle() {
        i=(i+1)%array.length;
    }
    
    
    public void setHelp(String helpstring) {
        help=helpstring;
    }
    
    public String getHelp() {
        return help;
    }
}
