
package Current.popups.Squarepath;
import Current.*;
import Current.basic.*;

import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;



public class Squarepath {


    public static String startsWith12(String W) {

	int n=W.length();
	int j0=Converter.getDigit(W,0);
	int j1=Converter.getDigit(W,1);
	if((j0==0)&&(j1==1)) return(W);
	for(int i=1;i<n;++i) {
	    j0=Converter.getDigit(W,i);
	    j1=Converter.getDigit(W,i+1);
	    if((j0==0)&&(j1==1)) {
		String W1=W.substring(i,n);
		String W0=W.substring(0,i);
		return(W1+W0);
	    }
	}
	return(W);
    }




    public Squarepath() {}

    //the word should start with 12//

  public static int[] wordToSquarepath(String W) {
     int[] raw={0,1,2};
     int[] state=new int[W.length()];
     int count=0;
     int sign=1;

     for(int i=2;i<=W.length();++i) {
        raw[0]=raw[1];
	raw[1]=raw[2];
	raw[2]=Converter.getDigit(W,i)+1;

	if((raw[1]==3)&&(raw[0]==raw[2])) {
	    state[count]=  state[count]+sign;    //go straight
	    }

       if((raw[1]==3)&&(raw[0]!=raw[2])) {
	   ++count;                                             //turn NE or SW
	   sign=-sign;                                      //switch sign
	   state[count]=sign;                           //start value at sign
       }

       if((raw[0]!=3)&&(raw[1]!=3)) {
	   ++count;                                          //turn NW or SE
	   state[count]=sign;                        //start value at sign
       }
     }
     state[0]=count;
     return(state);
  }



    public static String wedge1(int k) {
	String W=new String();
	W="";
	for(int i=1;i<Math.abs(k);++i) W=W+"13";
	W=W+"1";
	return(W);
    }

    public static String wedge2(int k) {
	String W=new String();
	W="";
	for(int i=1;i<Math.abs(k);++i) W=W+"23";
	W=W+"2";
	return(W);
    }




    public static String squarepathToWord(int[] s) {
	String W=new String();
	W="";

	for(int i=1;i<=s[0];++i) {
	    int i1=i;
	    int i2=i+1;
	    if(i2==s[0]+1) i2=1;

	    if(i%2==1) {
		W=W+wedge2(s[i]);
		if(s[i1]*s[i2]<0) W=W+"3";
	    }

	    if(i%2==0) {
		W=W+wedge1(s[i]);
		if(s[i1]*s[i2]<0) W=W+"3";
	    }
	}
	int n=W.length();
	W="1"+W.substring(0,n-1);
	return(W);
    }








    public static int[][] range(int[] state) {
	int[] r={0,0};
	int[][] R=new int[2][2];


	R[0][0]=+1000000;
	R[0][1]=-1000000;
	R[1][0]=+1000000;
	R[1][1]=-1000000;


	for(int i=1;i<state[0];i=i+2) {
	    r[0]=r[0]+state[i];
	    r[1]=r[1]+state[i+1];
	    if(R[0][0]>r[0]) R[0][0]=r[0];
	    if(R[0][1]<r[0]) R[0][1]=r[0];	    
            if(R[1][0]>r[1]) R[1][0]=r[1];
	    if(R[1][1]<r[1]) R[1][1]=r[1];
	}

	return(R);
    }


    public static int[] stateSum(int[] state) {
	int[] x={0,0};
	for(int i=1;i<=state[0];++i) {
	    if(i%2==1) x[0]=x[0]+state[i];
	    if(i%2==0) x[1]=x[1]+state[i];
	}
	return(x);
    }


    public static int palindromeTest(String W) {
	CombinatorialTriangle[] CT=CombinatorialTriangle.unfold(W);
	return(Converter.palindromeTest(CT));
    }




    public static String shiftLeft(String W1) {
	int n=W1.length();
	String W2=W1.substring(n-1,n)+W1.substring(0,n-1);
	return(W2);
    }


    public static String shiftRight(String W1) {
	int n=W1.length();
	String W2=W1.substring(1,n)+W1.substring(0,1);
	return(W2);
    }






    public static String toPalindrome(String W1) {
	String W2=new String(W1);
	int test=0;
	int count=0;
	while((test==0)&&(count<W1.length())) {
	    test=palindromeTest(W2);  
            if(test==0) W2=shiftRight(W2);
	    ++count;
	}
	return(W2);
    }




}







