package Current.basic;
import Current.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;

public class VertexPair {
    public int o1,e1,o2,e2;
    public int cert;
    public int a20,a11,a02;
    public int sign;

    public VertexPair() {}

    public VertexPair(int o1,int e1,int o2,int e2) {
	this.o1=o1;
	this.e1=e1;
	this.o2=o2;
	this.e2=e2;
	cert=0;
	a20=0;
	a11=0;
	a02=0;
    }

    public VertexPair(int o1,int e1,int o2,int e2,int c) {
	this.o1=o1;
	this.e1=e1;
	this.o2=o2;
	this.e2=e2;
	cert=c;
    }

    public VertexPair(int o1,int e1,int o2,int e2,int a20,int a11,int a02) {
	this.o1=o1;
	this.e1=e1;
	this.o2=o2;
	this.e2=e2;
	this.a20=a20;
	this.a11=a11;
	this.a02=a02;
	this.sign=sign;
    }

    public int compareTo(VertexPair X) {
	if(o1!=X.o1) return(1);	
        if(e1!=X.e1) return(1);
	if(o2!=X.o2) return(1);	
        if(e2!=X.e2) return(1);
	return(0);
    }


    public void print() {
	System.out.println(o1+" "+e1+"   "+o2+" "+e2+"       "+cert);
    }


}
