package Current.plot.Dyadic;
import Current.basic.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;

public class VertexPairOrganizer {

    public VertexPairOrganizer() {}

    public static int checkAppears(int a,int b,DyadicSquare Q) {
	for(int i=1;i<=Q.top[0];++i) {
	    for(int j=1;j<=Q.bot[0];++j) {
		if((a==Q.top[i])&&(b==Q.bot[j])) return(1);
	    }
	}
	return(0);
    }



    public static int[][] survivalList(DyadicSquare INIT,DyadicSquare[] IN,int IN_N,DyadicSquare[] DEF,int DEF_N) {
	int[][] x=new int[2][INIT.top.length+1];
	for(int i=1;i<=INIT.top.length;++i) {
	    x[0][i]=0;
	    x[1][i]=0;
	}

	for(int i=0;i<IN_N;++i) {
	    for(int j=1;j<=IN[i].top[0];++j) {
		x[0][IN[i].top[j]]=1;
	    }
	}

	for(int i=0;i<IN_N;++i) {
	    for(int j=1;j<=IN[i].bot[0];++j) {
		x[1][IN[i].bot[j]]=1;
	    }
	}


	for(int i=0;i<DEF_N;++i) {
	    for(int j=1;j<=DEF[i].top[0];++j) {
		x[0][DEF[i].top[j]]=1;
	    }
	}

	for(int i=0;i<DEF_N;++i) {
	    for(int j=1;j<=DEF[i].bot[0];++j) {
		x[1][DEF[i].bot[j]]=1;
	    }
	}


	int count0=1;
	int count1=1;
	int[][] y=new int[2][INIT.top.length+1];

	for(int i=1;i<=INIT.top.length;++i) 
	    if(x[0][i]==1) {
		y[0][count0]=i;
		++count0;
	    }
	y[0][0]=count0-1;

	for(int i=1;i<=INIT.top.length;++i) 
	    if(x[1][i]==1) {
		y[1][count1]=i;
		++count1;
	    }
	y[1][0]=count1-1;
	return(y);
    }
	


    public static int[][] pairSurvivalList(DyadicSquare INIT,DyadicSquare[] IN,int IN_N,DyadicSquare[] DEF,int DEF_N) {
	int[][] x=new int[INIT.top.length+1][INIT.top.length+1];
	for(int i=1;i<=INIT.top.length;++i) {	
          for(int j=1;j<=INIT.top.length;++j) {
	    x[i][j]=0;
	  }
	}


	for(int i=0;i<IN_N;++i) {
	    for(int j=1;j<=IN[i].top[0];++j) {
	      for(int k=1;k<=IN[i].bot[0];++k) {
		  x[IN[i].top[j]][IN[i].bot[k]]=1;
	      }
	    }
	}


	for(int i=0;i<DEF_N;++i) {
	    for(int j=1;j<=DEF[i].top[0];++j) {
	      for(int k=1;k<=DEF[i].bot[0];++k) {
		  x[DEF[i].top[j]][DEF[i].bot[k]]=1;
	      }
	    }
	}
	return(x);

    }
	


}