
package Current.popups.Deg100;
import Current.*;
import Current.basic.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;

public class Deg100Polygon {

    /**fields**/
    int[] n1,k1,n2,k2;
    double[] x,y;
    int n;
    int on;
    int type;
    int render;
    int number;
    Color C;
    String W;
    int bad;
    int[][] exceptions=new int[200][2];


    /**methods**/

    /**initialization method**/

    public Deg100Polygon() {}
    public Deg100Polygon(int n,int[] n1,int[] k1,int[] n2,int[] k2,Color C) {
	this.n=n;
	this.n1=n1;
	this.n2=n2;
	this.k1=k1;
	this.k2=k2;
        this.C=C;
	this.on=0;
	this.render=1;
	this.x=new double[10];
	this.y=new double[10];
	this.bad=0;
	for(int j=0;j<this.n;++j) {
	    this.x[j]=512.0*this.k1[j]/Math.pow(2,this.n1[j]);
	    this.y[j]=512.0*this.k2[j]/Math.pow(2,this.n2[j]);
	}
	exceptions[0][0]=0;
    }

    

    public Deg100Polygon(int dummy,int n,int[] n1,int[] k1,int[] n2,int[] k2,Color C) {
	this.n=n;
	this.n1=n1;
	this.n2=n2;
	this.k1=k1;
	this.k2=k2;
        this.C=C;
	this.on=0;
	this.x=new double[10];
	this.y=new double[10];
	this.render=1;
	for(int j=0;j<this.n;++j) {
	    this.x[j]=512.0*this.k1[j]/this.n1[j];
	    this.y[j]=512.0*this.k2[j]/this.n2[j];  
	}	
        exceptions[0][0]=0;
    }

    
    public Deg100Polygon override(int n,double[] x,double[] y,Color C) {
	Deg100Polygon Q=this;
	Q.n=n;
	for(int i=0;i<n;++i) {
	    Q.x[i]=512.0*x[i];
	    Q.y[i]=512.0*y[i];
	}
	Q.render=1;
	return(Q);
    }

    




    /*tells is a point is inside the polygon*/

    public int inside(Point p,double A,double Bx,double By) {
	int i,j,k,G1,G2;
	double x0,x1,x2,y0,y1,y2;
	double test;
	G1=0;
	G2=0;

	for(i=0;i<=this.n+1;++i) {
	    x0=p.x;
	    y0=p.y;
	    j=i;
	    k=i+1;
	    if(j>=this.n) j=j-this.n;
	    if(k>=this.n) k=k-this.n;
	    x1=x[j];
	    y1=y[j];
            x2=x[k];
	    y2=y[k];
	    x1=A*x1+Bx;
	    y1=A*y1+By;
	    x2=A*x2+Bx;
	    y2=A*y2+By;

	    test=x0*y1+x1*y2+x2*y0-y0*x1-y1*x2-y2*x0;
	    if(test>0) G2=1;
	    if(test<=0) G2=-1;
	    if((G1!=0)&&(G1!=G2)) return(0);
	    G1=G2;
	}
	return(1);
    }

}



