package Current.popups.Deg100;

import Current.*;
import Current.basic.*;
import Current.plot.Dyadic.*;
import Current.manage.*;

import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;

public class Deg100RationalPolygonPlotter {
    Manager M;
    Complex[] POLY;
    
    public Deg100RationalPolygonPlotter(Manager M) {
        this.M=M;
    }
    
    public void communicate() {
        Deg100Interface DI=(Deg100Interface)(M.mcbGet(Deg100Interface.class));
        if (DI!=null) {
            POLY=DI.getPOLY();
        }
    }
    
    public DyadicTile specialPlot(String word,Color C) {
        communicate();
        if(POLY==null) return(null);
        GeneralPath gp=new GeneralPath();
        SmallPolygon X=new SmallPolygon();
        X=new SmallPolygon(POLY,POLY.length);
        gp.append(X.toGeneralPath(),false);
        return (new DyadicTile(word, gp, C));
    }
    
}
