/*
 * GridManager.java
 *
 * Created on December 10, 2005, 1:44 PM
 */

package Current.popups.Grids;

import Current.manage.*;

import java.awt.*;
import java.awt.geom.*;

import Current.*;
import Current.manage.ParameterSpace.*;

/**
 *
 * @author  pat
 */
public class GridManager implements ParameterSpaceRenderer {
    
    public final RationalGrid[] grids=new RationalGrid[2];
    
    Manager M;
    public boolean draw=true;
    
    public GridManager(Manager M) {
        this.M=M;
        grids[0]=RationalGrid.standardHorizontal();
        grids[0].computeLines();
        grids[1]=RationalGrid.standardVertical();
        grids[1].computeLines();

        M.addRendererTop(this);
        //M.PSM.hide(this);
    }
    
    public void render(Graphics2D g, AffineTransform T) {
	if(draw) {
        g.setColor(M.PSM.color_settings.gridColor);
        for (int j=0; j<2; j++) {
            for (int i=0; i<grids[j].lines.length; i++) {
                if (grids[j].lines[i]!=null) {
                     g.draw(T.createTransformedShape(grids[j].lines[i]));
                } else {
                    System.out.println("Warning null line");
                }
            }
        }
	}
    }
        
}
