/*
 * HelpContainer.java
 *
 * Created on June 2, 2006, 5:52 PM
 */

package Current.popups.Help;

import Current.*;

import Current.manage.*;
import java.awt.*;

// temp
import java.util.Properties;

/**
 *
 * @author  pat
 */
public class HelpContainer extends Container {
    protected Manager M;
    public Help H;
    public HelpControls HC;
    
    public HelpContainer(Manager M) {
        this.M=M;
        H=new Help(M);
        init();
    }
    
    public HelpContainer(Manager M, HelpString hs) {
        this.M=M;
        H=new Help(M, hs);
        init();
    }

    public HelpContainer(Manager M, String file) {
        this.M=M;
        H=new Help(M, file);
        init();
    }
    
    private void init() {     
        //Properties p=System.getProperties();
        //p.list(System.out);
        
        M.addListener(this);
        HC=new HelpControls(H);
        this.setLayout(new BorderLayout());
        add(HC,"North");
        add(H,"Center");        
        validate();
    }
    
    public Dimension getPreferedSize() {
        return new Dimension(320,240);
    }
    
    public void mcbReceive(HelpDocument doc) {
        H.setPage(doc.file);
        HC.repaint();
        if (getParent() instanceof Window) {
            ((Window)getParent()).toFront();
        }
    }

    public void mcbReceive(HelpString hs) {
        H.setString(hs.str);
        HC.repaint();
        if (getParent() instanceof Window) {
            ((Window)getParent()).toFront();
        }
    }

    public void mcbCleanup() {
        M.remove(this);
    }
    
}
