package Current.popups.Help;

import Current.basic.*;

import java.awt.*;
import java.awt.event.*;


/**
 * This is the controls for the new help panel.
 *
 * I took this from the original ExplainCanvas.
 */
public class HelpControls extends Canvas implements MouseListener {
    
    Help H;
    
    ListenSquare F;
    IntegerSelector I1,I2,I3,I4;
    ListenSquare L;
    
    
    
    public HelpControls(Help H) {
        this.H=H;
        
        addMouseListener(this);
        setBackground(Color.black);
        I1=new IntegerSelector(185,5,40,20,50,25,200,10);
        I2=new IntegerSelector(25,5,40,20,0,0,199,1);
        I4=new IntegerSelector(105,5,40,20,1,1,20,1);
        I3=new IntegerSelector(265,5,40,20,12,8,22,1);
        L=new ListenSquare(2,2,12,12,Color.black);
        L.on=1;
        I2.val=0;
    }
    
    public Dimension getPreferredSize() {
        return new Dimension(345, 34);
    }
    
    public void paint(Graphics gfx) {
        
        
        Graphics2D g=(Graphics2D) gfx;
        
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);
        
        I3.val=H.font_size;
        I2.val=H.line_scroll;
        
        L.infoRender(g);
        //I1.render(g,Color.red,Color.white,Color.red);
        I2.render(g,new Color(50,100,255),Color.white,new Color(100,150,255));
        I3.render(g,new Color(0,255,0),Color.white,new Color(0,220,0));
        I4.render(g,new Color(0,0,220),Color.white,new Color(50,100,255));
    }
    
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {
        Point X=new Point();
        e.consume();
        X.x=e.getX();
        X.y=e.getY();
        
        //I1.modify(X);
        I2.modify(X);
        if (I2.val!=H.line_scroll) {
            H.line_scroll=I2.val;
            H.resetScroll();
        }
        I3.modify(X);
        if (I3.val!=H.font_size) {
            H.font_size=I3.val;
            H.reset();
        }
        I4.modify(X);
        
        I2.step=I4.val;
        if(L.inside(X)==1) H.setPage("about.html");
        repaint();
    }
    
    
}
