/*
 * Status.java
 *
 * Created on September 11, 2006, 1:33 PM
 */

package Current.popups.ListPlotter;

import Current.gui.DBCanvas;

import org.pat.graphics.boxed.ListenString;

import java.awt.*;

/**
 *
 * @author  pat
 */
public class Status extends DBCanvas {
    WordListPlotCanvas wlpc;
    ListenString ls;
    
    /** Creates a new instance of Status */
    public Status(WordListPlotCanvas wlpc) {
        setFont(new Font("sanserif", Font.PLAIN, 12));
        setBackground(new Color(0,120,255));
        
        ls=new ListenString("",this);
        ls.setColors(Color.BLACK,Color.ORANGE);
        ls.setTop(4);
        setSize(200, (int)(ls.getBottom()+4));
        
        this.wlpc=wlpc;
    }
    
    public void setMessage() {
        if (wlpc.isPlotting()) {
            ls.str="plotting: "+wlpc.wlpp.wl.size()+" words remain";
        } else {
            if (wlpc.wlpp.wl.size() == 0) {
                ls.str="done plotting";
            } else {
                ls.str="not plotting: "+wlpc.wlpp.wl.size()+" words remain";
            }
        }
        ls.size();
    }
    
    public void paint(Graphics gfx) {
        Graphics2D g=(Graphics2D) gfx;
        
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);

        setMessage();
        ls.setHorizontalCenter(getWidth()/2.0);        
        ls.render(g);
    }
    
}
