/*
 * McbFileLoader.java
 *
 * Created on November 6, 2005, 8:23 PM
 */

package Current.popups.OldMemory;

import java.awt.Color;
import java.util.*;
import java.io.*;
import java.net.URL;

import Current.manage.*;

/**
 *
 * @author  pat
 */
public class FileLoader {
    public interface FilePlottingNotify {
        public void filePlottingComplete();
    }
    
    //    private class FileTilePlotter extends Thread {
    //        Manager M;
    //        String name; // name of file to load
    //
    //        public FileTilePlotter(Manager M, String name) {
    //            this.M=M;
    //            this.name=name;
    //        }
    //
    //        public void run() {
    //            int num=0;
    //            try {
    //                String thisLine;
    //                InputStream is = getClass().getResourceAsStream("Files/Memory/"+name);
    //                BufferedReader br = new BufferedReader(new InputStreamReader(is));
    //
    //                String[] terms;
    //                while ((thisLine = br.readLine()) != null) {
    //                    num++; // line number in file
    //                    terms=thisLine.split(" ");
    //                    if (terms[0].equals("BEGIN")) {
    //                        PI.reset();
    //                    } else if (terms[0].equals("word")) {
    //                        PI.setWord(terms[1]);
    //                    } else if (terms[0].equals("center")) {
    //                        PI.setCenter(new Complex(Double.parseDouble(terms[1]),
    //                        Double.parseDouble(terms[2])));
    //                    } else if (terms[0].equals("color")) {
    //                        int[] x=new int[3];
    //                        char ch;
    //                        for (int i=0; i<3; i++) {
    //                            ch=terms[1].charAt(i);
    //                            if ((ch>='0')&&(ch<='9')) {
    //                                x[i]=(int)(ch-'0');
    //                            } else if ((ch>='a')&&(ch<='f')) {
    //                                x[i]=(int)(ch-'a'+10);
    //                            }
    //                        }
    //                        PI.setColor(new Color((float)x[0]/15,
    //                        (float)x[1]/15,(float)x[2]/15));
    //                    } else if (terms[0].equals("vertex_number")) {
    //                        if (terms.length>1) {
    //                            try {
    //                                ExternNewtonPlot.NewtonVertexList v=
    //                                new ExternNewtonPlot.NewtonVertexList(Integer.parseInt(terms[1]));
    //                                for (int i=0; i<v.length(); i++) {
    //                                    thisLine = br.readLine();
    //                                    num++;
    //                                    if (thisLine==null) {
    //                                        System.out.println("not enough vertices given");
    //                                        return;
    //                                    }
    //                                    terms=thisLine.split(" ");
    //                                    v.vert[i]=new Complex(
    //                                    Double.parseDouble(terms[0]),
    //                                    Double.parseDouble(terms[1]));
    //                                    v.a[i]=Integer.parseInt(terms[2]);
    //                                    v.b[i]=Integer.parseInt(terms[3]);
    //                                }
    //                                PI.setVertices(v);
    //                            } catch (Exception e) {
    //                                System.out.println("Error reading from Files/Memory/"+name+
    //                                ". Here is some debugging info:");
    //                                System.out.println("Error occured when reading vertex from line "+num+" from file.");
    //                                e.printStackTrace();
    //                            }
    //                        }
    //                    } else if (terms[0].equals("END")) {
    //                        PI.plotNoThread();
    //                    }
    //                }
    //            }
    //            catch (Exception e) {
    //                System.out.println("Error reading from Files/Memory/"+name+
    //                ". Here is some debugging info:");
    //                System.out.println("Error occured when reading line "+num+" from file.");
    //                e.printStackTrace();
    //            }
    //            FTP=null;
    //            if (FPN!=null) {
    //                FPN.filePlottingComplete();
    //            }
    //        }
    //    }
    Manager M;
    
    public String[] file_names;
    //private FileTilePlotter FTP;
    private FilePlottingNotify FPN;
    
    public void notify(FilePlottingNotify FPN){
        this.FPN=FPN;
    }
    
    /** Creates a new instance of FileLoader */
    public FileLoader(Manager M) {
        this.M=M;
        LinkedList ll=new LinkedList();
        try {
            
            String thisLine;
            InputStream is = M.getInputStream("Files/memory_files");
            
            BufferedReader br = new BufferedReader(new InputStreamReader(is));
            thisLine = br.readLine();
            if (thisLine!=null)
                do {
                    //System.out.println(thisLine);
                    ll.add(thisLine);
                } while ((thisLine = br.readLine()) != null);
            else
                System.out.println("No Memory files found.");
        }
        catch (Exception e) {
            System.err.println("Error reading Memory files...");
            System.err.flush();
            e.printStackTrace();
        }
        file_names=new String[ll.size()];
        int i=0;
        for (ListIterator it=ll.listIterator(); it.hasNext();i++){
            file_names[i]=(String)it.next();
        }
    }
    
    public String getName(int i) {
        return file_names[i];
    }
    
    //    public boolean isPlotting() {
    //        return FTP!=null;
    //    }
    
    //    public boolean plot(Manager M, int index) {
    //        return plot(M,file_names[index]);
    //    }
    
    //    public boolean plot(Manager M, String name) {
    //        if (FTP==null) {
    //            FTP=new FileTilePlotter(M,name,PI);
    //            FTP.start();
    //            return true;
    //        } else {
    //            return false;
    //        }
    //    }
}
