/*
 * McbSettingsPopup.java
 *
 * Created on May 12, 2006, 11:22 AM
 */

package Current.popups.Settings;

import java.awt.*;

import Current.popups.Settings.Items.SettingsObject;
import Current.manage.*;

/**
 *
 * @author  pat
 */
public class SettingsPopup extends Container {
    Manager M;
    
    
    
    Title MST;
    private Component center;
    
    /** Creates a new instance of McbSettingsPopup */
    public SettingsPopup(Manager M) {
        this.M=M;
        M.addListener(this);
        
        MST=new Title(M,this);
        
        setLayout(new BorderLayout());
        add(MST,"North");
        Canvas C=M.settingsManager.getList(this);
        C.setSize(200, 300);
        setCenter(C);
    }
    
    public void setCenter(Component C) {
        invalidate();
        if (center!=null) {
            M.cleanupObject((Object)center);
            remove(center);
        }
        center=C;
        add(center,"Center");
        validate();
    }
    
    public void mcbReceive(SettingsRequest req) {
        SettingsObject so=
        (SettingsObject)(M.settings.class_map.get(req.C));
        setCenter(new ItemList(M,so));
        ((Window)(this.getParent())).toFront();
    }
    
    public void mcbCleanup() {
        M.cleanupObject((Object)center);
        remove(center);
        M.remove(this);
    }
    
}
