package Current.popups.Squarepath;

import Current.*;
import Current.manage.*;

import java.awt.*;
import java.awt.event.*;
import java.io.Serializable;


public class SquarepathContainer extends Container {
    protected Manager M;  
    public SquarepathCanvas A;
    public SquarepathControlCanvas AC;
    public Container C;
    
    /** Creates a new instance of UnfoldContainer */
    public SquarepathContainer(Manager M) {
        this.M=M;
	M.addListener(this);
        C=new Container();
        C.setLayout(new BorderLayout());
        A=new SquarepathCanvas(M,this);
        AC=new SquarepathControlCanvas(M,A);
        A.addSquarepathControlCanvas(AC);
        AC.addSquarepathContainer(this);
        A.setSize(301,200);
        AC.setSize(301,400);
        setLayout(new BorderLayout());
        add(A,"Center");
        add(AC,"South");
        setBackground(Color.black);
    }
    

    
    /** This must be called when the containing popup is closed, so that
     * the manager no longer tries to contact these components. */
    public void mcbCleanup() {
        M.remove(AC);
        M.remove(A);
    }

}
