package Current.search;

import Current.search.Results;

import Current.basic.*;

/**
 *
 * @author  pat
 */
public class BasicSearchResults {
    public String[] words;
    public Complex z;
    
    public BasicSearchResults(Results r) {
        words=r.words;
        z=new Complex(r.z.x, r.z.y);
    }
    
    /** Creates a new instance of BasicSearchResults */
    public BasicSearchResults(String[] words, Complex z) {
        this.words=words;
        this.z=z;
    }

    public BasicSearchResults(Complex z) {
        this.words=new String[0];
        this.z=z;
    }
}
