/*
 * XfigArrow.java
 *
 * Created on May 5, 2006, 11:03 AM
 */

package org.pat.graphics.arrows;

import java.awt.*;
import java.awt.geom.*;

/**
 *
 * @author  pat
 */
public class XFigArrow implements ArrowStyle {
    /** arrow types */
    static int BENT_ARROW=0;
    
    BasicStroke S=new BasicStroke((float)1.0);
    float width=4;
    float height=8;
    boolean mul_line_thickness=true;
    int type=BENT_ARROW;

    /** Creates a new instance of XfigArrow */
    public XFigArrow() {
    }
    
    
    /** return an arrow point in the x direction based at the origin */
    public Shape standardArrow(){
        GeneralPath GP=new GeneralPath();
        GP.moveTo(-height,width/2);
        GP.lineTo(0,0);
        GP.lineTo(-height,-width/2);
        return GP;
    }
    
    //public void drawArrow(Graphics2D g, double x, double y) {
    //    Stroke previous_stroke=g.getStroke();
    //    
    //}
}
