/*
 * ClassComparator.java
 *
 * Created on May 22, 2006, 11:07 AM
 */

package org.pat.util;

import java.util.Comparator;
import java.io.Serializable;

/**
 * Compares classes using the lexigraphical ordering of the class name
 * @author  pat
 */
public class ClassComparator implements Comparator, Serializable {
    
    /** Creates a new instance of ClassComparator */
    public ClassComparator() {
    }
    
    public int compare(Object obj, Object obj1) {
        return ((Class)obj).getName().compareTo(((Class)obj1).getName());
    }
    
}
